SystemOrganization addCategory: #'NXTalk-ST-Kernel'!
SystemOrganization addCategory: #'NXTalk-Building'!
SystemOrganization addCategory: #'NXTalk-ST-Collections'!
SystemOrganization addCategory: #'NXTalk-ST-Tests'!
SystemOrganization addCategory: #'NXTalk-Building-Tests'!
SystemOrganization addCategory: #'NXTalk-User Interface'!
SystemOrganization addCategory: #'NXTalk-ST-Hardware'!
SystemOrganization addCategory: #'NXTalk-Connections'!
SystemOrganization addCategory: #'NXTalk-ST-Streams'!
SystemOrganization addCategory: #'NXTalk-ST-Programs'!

!String methodsFor: '*nxtalk' stamp: 'mab 6/6/2008 11:13'!
asNXTObject
	| string |
	string := NXTString new: self size.
	^ string replaceFrom: 1 to: self size with: self! !

!String methodsFor: '*nxtalk' stamp: 'mab 7/25/2008 19:53'!
print
	Transcript show: self.! !

!String methodsFor: '*nxtalk' stamp: 'mab 7/25/2008 19:53'!
printNl
	self print.
	Transcript cr.! !

!SmallInteger methodsFor: '*nxtalk' stamp: 'mab 9/8/2008 12:28'!
asNXTLargeInteger: positive
	| size nxtObject |
	size := self digitLength.
	nxtObject := positive 
		ifTrue: [ NXTLargePositiveInteger new: size ]
		ifFalse: [ NXTLargeNegativeInteger new: size ].
	1 to: size do: [ :i | nxtObject at: i put: (self digitAt: i) ].
	^ nxtObject! !

!SmallInteger methodsFor: '*nxtalk' stamp: 'mab 9/8/2008 11:46'!
asNXTObject
	self > NXTSmallInteger maxVal ifTrue: [
		^ self asNXTLargeInteger: true ].
	self < NXTSmallInteger minVal ifTrue: [
		^ self asNXTLargeInteger: false ].
	^ self! !

!SmallInteger methodsFor: '*nxtalk' stamp: 'mab 9/1/2008 18:21'!
writeAsReferenceOn: aByteStream within: image
	(self < -16r4000 or: [ self > 16r3FFF ]) ifTrue: [ self error: 'Too large smallint!!' ].
	self >= 0 
		ifTrue: [ aByteStream littleEndianWord: (self bitShift: 1) ]
		ifFalse: [ aByteStream 
			littleEndianWord: (16r8000 + self bitShift: 1) ]! !

PositionableStream subclass: #NXTConnection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Connections'!

!NXTConnection class methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 09:59'!
flashImage
| stream connection |
stream := RWBinaryOrTextStream on: String new.
NXTImageBuilder new helloWorldImageOn: stream binary.
connection := self connect.
connection nextLittleEndianNumber: 4 put: stream size.
connection flush.
30 milliSeconds asDelay wait.
1 to: stream contents size by: 64 do: [ :i |
	connection nextPutAll: (stream contents 
		copyFrom: i 
		to: (i + (63 min: stream contents size - i))).
	connection flush.
	30 milliSeconds asDelay wait.
].
connection close.! !

!NXTConnection methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 14:54'!
ascii
	"NXT connections are always binary for now"! !

!NXTConnection methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 14:53'!
binary
	"NXT connections are always binary for now"! !

!NXTConnection methodsFor: 'as yet unclassified' stamp: 'mab 8/12/2008 10:43'!
close
	^ self stream close! !

!NXTConnection methodsFor: 'streaming' stamp: 'mab 7/4/2008 17:26'!
flush
	^ self stream flush! !

!NXTConnection methodsFor: 'streaming' stamp: 'mab 7/2/2008 16:43'!
littleEndianWord
	self nextLittleEndianNumber: 2! !

!NXTConnection methodsFor: 'streaming' stamp: 'mab 7/2/2008 16:43'!
littleEndianWord: number
	self nextLittleEndianNumber: 2 put: number! !

!NXTConnection methodsFor: 'as yet unclassified' stamp: 'mab 7/29/2008 13:14'!
next
	^ self stream next! !

!NXTConnection methodsFor: 'streaming' stamp: 'mab 7/2/2008 16:44'!
nextLittleEndianNumber: n 
	"Answer the next n bytes as a positive Integer or LargePositiveInteger, where the bytes are ordered from least significant to most significant."

	| bytes s |
	bytes := self next: n.
	s := 0.
	n to: 1 by: -1 do: [:i | s := (s bitShift: 8) bitOr: (bytes at: i)].
	^ s
! !

!NXTConnection methodsFor: 'streaming' stamp: 'mab 7/2/2008 16:44'!
nextLittleEndianNumber: n put: value
	"Answer the next n bytes as a positive Integer or LargePositiveInteger, where the bytes are ordered from least significant to most significant."
	| bytes |
	bytes := ByteArray new: n.
	1 to: n do: [: i | bytes at: i put: (value digitAt: i)].
	self nextPutAll: bytes! !

!NXTConnection methodsFor: 'streaming' stamp: 'mab 7/2/2008 16:48'!
nextPut: anObject
	self stream nextPut: anObject! !

!NXTConnection methodsFor: 'streaming' stamp: 'mab 7/2/2008 16:45'!
nextPutAll: aCollection
	self stream nextPutAll: aCollection! !

!NXTConnection methodsFor: 'as yet unclassified' stamp: 'mab 6/22/2008 13:51'!
sendData: aStringOrByteArray
	self subclassResponsibility! !

!NXTConnection methodsFor: 'as yet unclassified' stamp: 'mab 7/2/2008 16:09'!
stream
	self subclassResponsibility! !

NXTConnection subclass: #NXTSerialConnection
	instanceVariableNames: 'serialPort'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Connections'!

!NXTSerialConnection class methodsFor: 'as yet unclassified' stamp: 'mab 6/19/2008 17:12'!
connect
	^ self new serialPort: (SerialPort new openPort: 3)! !

!NXTSerialConnection class methodsFor: 'as yet unclassified' stamp: 'mab 8/14/2008 11:47'!
new
	^ self basicNew initialize! !

!NXTSerialConnection methodsFor: 'as yet unclassified' stamp: 'mab 8/14/2008 11:51'!
close
	^ self serialPort close! !

!NXTSerialConnection methodsFor: 'as yet unclassified' stamp: 'mab 7/4/2008 17:26'!
flush
	! !

!NXTSerialConnection methodsFor: 'accessing' stamp: 'mab 7/16/2008 18:27'!
nextPut: anInteger
	self nextPutAll: (String with: anInteger asCharacter)! !

!NXTSerialConnection methodsFor: 'accessing' stamp: 'mab 7/3/2008 13:38'!
nextPutAll: aCollection
	self serialPort nextPutAll: aCollection! !

!NXTSerialConnection methodsFor: 'accessing' stamp: 'mab 6/19/2008 17:12'!
serialPort
	^ serialPort! !

!NXTSerialConnection methodsFor: 'accessing' stamp: 'mab 6/19/2008 17:12'!
serialPort: anObject
	serialPort := anObject! !

NXTConnection subclass: #NXTSocketConnection
	instanceVariableNames: 'socketStream bytesWritten'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Connections'!

!NXTSocketConnection class methodsFor: 'as yet unclassified' stamp: 'mab 6/22/2008 14:01'!
connect
	^ self localhost! !

!NXTSocketConnection class methodsFor: 'as yet unclassified' stamp: 'mab 7/2/2008 16:47'!
localhost
	^ self on: (SocketStream openConnectionToHostNamed: '127.0.0.1' port: 10000) binary! !

!NXTSocketConnection class methodsFor: 'as yet unclassified' stamp: 'mab 7/21/2008 14:32'!
on: socket
	^ self basicNew 
		initialize;
		socketStream: socket! !

!NXTSocketConnection methodsFor: 'as yet unclassified' stamp: 'mab 7/2/2008 16:59'!
initialize
	bytesWritten := 0! !

!NXTSocketConnection methodsFor: 'as yet unclassified' stamp: 'mab 7/2/2008 16:55'!
nextPut: anObject
	bytesWritten := bytesWritten + 1.
	super nextPut: anObject! !

!NXTSocketConnection methodsFor: 'as yet unclassified' stamp: 'mab 7/2/2008 16:55'!
nextPutAll: aCollection
	bytesWritten := bytesWritten + aCollection size.
	super nextPutAll: aCollection! !

!NXTSocketConnection methodsFor: 'as yet unclassified' stamp: 'mab 7/2/2008 17:00'!
position
	^ bytesWritten! !

!NXTSocketConnection methodsFor: 'as yet unclassified' stamp: 'mab 6/22/2008 13:52'!
sendData: aStringOrByteArray
	self socketStream
		nextPutAll: aStringOrByteArray;
		flush.! !

!NXTSocketConnection methodsFor: 'accessing' stamp: 'mab 6/19/2008 14:18'!
socketStream
	^ socketStream! !

!NXTSocketConnection methodsFor: 'accessing' stamp: 'mab 6/19/2008 14:18'!
socketStream: anObject
	socketStream := anObject! !

!NXTSocketConnection methodsFor: 'as yet unclassified' stamp: 'mab 7/2/2008 16:09'!
stream
	^ self socketStream! !

NXTConnection subclass: #NXTUsbConnection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Connections'!

!PositionableStream methodsFor: '*nxtalk' stamp: 'mab 7/2/2008 17:50'!
littleEndianWord
	self nextLittleEndianNumber: 2! !

!PositionableStream methodsFor: '*nxtalk' stamp: 'mab 7/2/2008 17:50'!
littleEndianWord: number
	self nextLittleEndianNumber: 2 put: number! !

!LargeNegativeInteger methodsFor: '*nxtalk' stamp: 'mab 9/8/2008 11:30'!
asNXTObject
	| size nxtObject |
	size := self digitLength.
	nxtObject := NXTLargeNegativeInteger new: size.
	1 to: size do: [ :i | nxtObject at: i put: (self at: i) ].
	^ nxtObject! !

!Array methodsFor: '*nxtalk' stamp: 'mab 7/21/2008 15:41'!
asNXTObject
	| nxtArray |
	nxtArray := NXTArray new: self size.
	self doWithIndex: [ :element :index |
		nxtArray at: index put: element asNXTObject ].
	^ nxtArray! !

TestCase subclass: #NXTImageTest
	instanceVariableNames: 'image'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building-Tests'!

!NXTImageTest methodsFor: 'as yet unclassified' stamp: 'mab 6/2/2008 18:17'!
setUp
	image := NXTImage new.
	image specialObjects at: #runSymbol put: (image symbolAt: #run).! !

!NXTImageTest methodsFor: 'as yet unclassified' stamp: 'mab 6/2/2008 19:17'!
testObjectCountDoesNotChangeAfterWrite
	self 
		shouldnt: [ image writeToStream: (MultiByteBinaryOrTextStream with: String new) binary ]
		raise: Exception.! !

!LargePositiveInteger methodsFor: '*nxtalk' stamp: 'mab 9/8/2008 11:24'!
asNXTObject
	| size nxtObject |
	size := self digitLength.
	nxtObject := NXTLargePositiveInteger new: size.
	1 to: size do: [ :i | nxtObject at: i put: (self at: i) ].
	^ nxtObject! !

!Symbol methodsFor: '*nxtalk' stamp: 'mab 6/6/2008 11:14'!
asNXTObject
	| symbol |
	symbol := NXTSymbol new: self size.
	^ symbol replaceFrom: 1 to: self size with: self! !

Object subclass: #NXTClassCompiler
	instanceVariableNames: 'image compiledClass superclass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTClassCompiler methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 15:02'!
compile: aClass into: anNXTClass
	| metaclass |
	self compiledClass: aClass.
	metaclass := NXTMetaclass new.
	self image classMapping at: anNXTClass put: metaclass.
	self superclass: self compileSuperclass.
	self fillEmptyClass: anNXTClass.
	self createMetaclassIn: metaclass.
	self compileDependencies.! !

!NXTClassCompiler methodsFor: 'as yet unclassified' stamp: 'mab 8/12/2008 14:41'!
compileDependencies
	self compiledClass includes do: [ :each |
		self image classAt: each name ].! !

!NXTClassCompiler methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 15:03'!
compileSuperclass
	^ self compiledClass name = #NXTObject
		ifFalse: [ self image classAt: self compiledClass superclass name ]
		ifTrue: [ nil ]! !

!NXTClassCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:21'!
compiledClass
	^ compiledClass! !

!NXTClassCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:21'!
compiledClass: anObject
	compiledClass := anObject! !

!NXTClassCompiler methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 14:46'!
createMetaclassIn: metaclass
	self image addObject: metaclass.
	metaclass name: (self image symbolAt: (self compiledClass name, ' class') asSymbol).
	self superclass isNil
		ifFalse: [ metaclass superclass: (self image classMapping at: self superclass) ]
		ifTrue: [ metaclass superclass: (self image specialObjectAt: #nil) ].
	metaclass format: 2.
	self includeInstanceVariablesOf: self compiledClass class in: metaclass.
	self includeMethodDictionaryOf: self compiledClass class in: metaclass.
	^ metaclass! !

!NXTClassCompiler methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 15:41'!
fillEmptyClass: class
	self image addObject: class.
	class name: (self image symbolAt: self compiledClass name).
	class format: (self compiledClass elementSize bitOr: self compiledClass allInstVarNames size << 2).
	self superclass isNil
		ifFalse: [ class superclass: self superclass ]
		ifTrue: [ class superclass: (self image specialObjectAt: #nil) ].
	self includeMethodDictionaryOf: self compiledClass in: class.
	self includeInstanceVariablesOf: self compiledClass in: class.
	^ class! !

!NXTClassCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:21'!
image
	^ image! !

!NXTClassCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:21'!
image: anObject
	image := anObject! !

!NXTClassCompiler methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 17:38'!
includeInstanceVariablesOf: aClass in: aNXTClass
	| instVarNames |
	instVarNames := NXTArray new: aClass instVarNames size.
	self image addObject: instVarNames.
	aNXTClass instVarNames: instVarNames.
	aClass instVarNames doWithIndex: [ :name :index |
		instVarNames at: index put: (self image symbolAt: name asSymbol) ]! !

!NXTClassCompiler methodsFor: 'as yet unclassified' stamp: 'mab 6/3/2008 13:57'!
includeMethodDictionaryOf: aClass in: aNXTClass
	| methodDictionary method index selectors |
	index := 1.
	selectors := aClass selectors reject: [ :selector |
		(aClass organization categoryOfElement: selector) = #'nxt-exclude' ].
	methodDictionary := NXTArray new: selectors size * 2.
	self image addObject: methodDictionary.
	aNXTClass methodDictionary: methodDictionary.
	selectors do: [ :selector |
		method := NXTMethodCompiler new
			compilerContext: self;
			compileMethod: (aClass compiledMethodAt: selector).
		self image addObject: method.
		methodDictionary at: index put: (self image symbolAt: selector).
		methodDictionary at: index + 1 put: method.
		index := index + 2 ].! !

!NXTClassCompiler methodsFor: 'as yet unclassified' stamp: 'mab 5/21/2008 10:49'!
includeSuperclass
	self compiledClass name = #NXTObject
		ifFalse: [ self classObject 
			superclass: (self image classAt: self compiledClass superclass name) ]
		ifTrue: [ self classObject 
			superclass: (self image specialObjectAt: #nil) ].! !

!NXTClassCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:22'!
instVarNames
	^ self compiledClass allInstVarNames! !

!NXTClassCompiler methodsFor: 'accessing' stamp: 'mab 5/21/2008 14:39'!
superclass
	^ superclass! !

!NXTClassCompiler methodsFor: 'accessing' stamp: 'mab 5/21/2008 14:39'!
superclass: anObject
	superclass := anObject! !

Object subclass: #NXTImage
	instanceVariableNames: 'objects specialObjects symbols classes paddings classMapping mapper finished systemDictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTImage class methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 14:13'!
specialClasses
	^ {
	#NXTSmallInteger.
	#NXTLargePositiveInteger.
	#NXTLargeNegativeInteger.
	#NXTString.
	#NXTMethod.
	#NXTBlock.
	#NXTSymbol.
	#NXTMethodFrame.
	#NXTBlockFrame.
	#NXTArray.
	#NXTProcess.
	}! !

!NXTImage class methodsFor: 'as yet unclassified' stamp: 'mab 9/3/2008 15:15'!
specialObjects
	^ {
	#System -> #NXTSystem.
	#nil -> #NXTUndefinedObject.
	#true -> #NXTTrue. 
	#false -> #NXTFalse.
	#Processor -> #NXTProcessorScheduler.
	}! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 8/15/2008 16:23'!
addObject: anNXTObject
	self finished ifTrue: [ Error signal: 'Image is already finished' ].
	anNXTObject isNXTObject
		ifTrue: [ ^ self objects add: anNXTObject ]
		ifFalse: [ Error signal: 'Attempt to insert non-NXTObject into image' ]! !

!NXTImage methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 11:44'!
classAt: aClassName
	| newClass |
	(aClassName endsWith: ' class') ifTrue: [
		^ classMapping at: (self classAt: (aClassName allButLast: 6) asSymbol) ].
	^ classes at: aClassName ifAbsent: [ 
		newClass := classes at: aClassName put: NXTClass new.
		NXTClassCompiler new
			image: self;
			compile: (Smalltalk at: aClassName) into: newClass.
		newClass ]! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 5/21/2008 14:41'!
classMapping
	^ classMapping! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 5/21/2008 14:41'!
classMapping: anObject
	classMapping := anObject! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 6/2/2008 19:14'!
finished
	^ finished! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 6/2/2008 19:14'!
finished: anObject
	finished := anObject! !

!NXTImage methodsFor: 'as yet unclassified' stamp: 'mab 6/2/2008 19:00'!
includeClasses
	| changed |
	changed := true.
	[ changed ] whileTrue: [
		changed := false.
		self objects do: [ :object |
			(object class inheritsFrom: NXTImageObject) ifTrue: [
				object nxtClass isSymbol ifTrue: [
					changed := true.
					object nxtClass: (self classAt: object nxtClass) ]]
				ifFalse: [ self classAt: object class name ]]].! !

!NXTImage methodsFor: 'as yet unclassified' stamp: 'mab 9/10/2008 19:11'!
includeDependentObjects
	self includeSpecialObjects.
	self includeSpecialClasses.
	self includeClasses.
	self includeMetaclass.
	self includeSubclassRelations.
	self includeSystemDictionary.! !

!NXTImage methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 14:29'!
includeMetaSubclassRelationFor: className
	| subclasses describedClass |
	(className endsWith: ' class') ifFalse: [ ^ nil ].
	describedClass := (className allButLast: 6) asSymbol.
	subclasses := (Smalltalk at: describedClass) class subclasses 
		select: [ :class | self includesClass: class name ].
	subclasses doWithIndex: [ :class :index |
		subclasses at: index put: (classMapping at: (self classAt: describedClass))].
	subclasses := NXTArray withAll: subclasses.
	self addObject: subclasses.
	(classMapping at: (self classAt: describedClass)) subclasses: subclasses.! !

!NXTImage methodsFor: 'as yet unclassified' stamp: 'mab 5/22/2008 16:38'!
includeMetaclass
	| metaclass |
	metaclass := self classAt: #NXTMetaclass.
	self objects do: [ :object |
		object isMeta ifTrue: [ self classMapping at: object put: metaclass ]].
	"NXTObject class superclass = NXTClass"
	(self classMapping at: (self classAt: #NXTObject)) superclass: (self classAt: #NXTClass).! !

!NXTImage methodsFor: 'as yet unclassified' stamp: 'mab 4/29/2008 15:02'!
includeSpecialClasses
	self class specialClasses do: [ :class |
		self classAt: class ].! !

!NXTImage methodsFor: 'as yet unclassified' stamp: 'mab 4/29/2008 00:32'!
includeSpecialObjects
	self class specialObjects do: [ :assoc |
		self specialObjectAt: assoc key ].! !

!NXTImage methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 14:22'!
includeSubclassRelationFor: className
	| subclasses |
	subclasses := (Smalltalk at: className) subclasses 
		select: [ :class | self includesClass: class name ].
	subclasses doWithIndex: [ :class :index |
		subclasses at: index put: (self classAt: class name)].
	subclasses := NXTArray withAll: subclasses.
	self addObject: subclasses.
	(self classAt: className) subclasses: subclasses.! !

!NXTImage methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 14:27'!
includeSubclassRelations
	classes keysDo: [ :className |
		self includeSubclassRelationFor: className ].
	classMapping valuesDo: [ :metaclass |
		self includeMetaSubclassRelationFor: metaclass name asSqueakObject ].! !

!NXTImage methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 17:51'!
includeSystemDictionary
	| array |
	classes valuesDo: [ :class |
		self systemDictionary at: class name put: class ].
	"Transpose our nil to new image nil in Dictionary,
	also add all Associations to the image"
	array := self systemDictionary instVarNamed: #array.
	array withIndexDo: [ :each :index | each 
			ifNil: [ array at: index put: (self specialObjectAt: #nil) ]
			ifNotNil: [ self addObject: each ]].
	self addObject: array.! !

!NXTImage methodsFor: 'testing' stamp: 'mab 7/25/2008 11:38'!
includesClass: aClassName
	^ (classes includesKey: aClassName) or: [ classMapping anySatisfy: [ :metaclass | metaclass name asSqueakObject = aClassName ]]! !

!NXTImage methodsFor: 'as yet unclassified' stamp: 'mab 6/2/2008 19:14'!
initialize
	objects := OrderedCollection new.
	specialObjects := Dictionary new.
	symbols := Dictionary new.
	classes := Dictionary new.
	paddings := 0.
	classMapping := Dictionary new.
	finished := false.! !

!NXTImage methodsFor: 'accessing special objects' stamp: 'mab 4/28/2008 23:31'!
isSpecialObject: aSymbol
	^ self class specialObjects detect: [ :each |
		each key = aSymbol ] ifNone: [ false ].! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 5/21/2008 14:53'!
mapper
	^ mapper! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 5/21/2008 14:53'!
mapper: anObject
	mapper := anObject! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 2/20/2008 03:06'!
objects
	^ objects! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 2/20/2008 03:06'!
objects: anObject
	objects := anObject! !

!NXTImage methodsFor: 'accessing special objects' stamp: 'mab 8/15/2008 17:07'!
specialObjectAt: aSymbol
	| specialObject specialClass|
	^ specialObjects at: aSymbol ifAbsentPut: [
		specialClass := Smalltalk at: (self specialObjectClassAt: aSymbol).
		specialObject := specialClass new.
		specialClass instVarNames do: [ :name |
			specialObject instVarNamed: name put: (self specialObjectAt: #nil) ].
		self addObject: specialObject ]! !

!NXTImage methodsFor: 'accessing special objects' stamp: 'mab 4/28/2008 23:36'!
specialObjectClassAt: aSymbol
	^ (self class specialObjects detect: [ :each | each key = aSymbol ]) value! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 2/20/2008 03:06'!
specialObjects
	^ specialObjects! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 2/20/2008 03:06'!
specialObjects: anObject
	specialObjects := anObject! !

!NXTImage methodsFor: 'as yet unclassified' stamp: 'mab 6/6/2008 11:14'!
symbolAt: aSymbol
	^ symbols at: aSymbol ifAbsentPut: [ self addObject: aSymbol asNXTObject ]! !

!NXTImage methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 17:34'!
systemDictionary
	^ systemDictionary ifNil: [
		systemDictionary := NXTDictionary new.
		self addObject: systemDictionary ]! !

!NXTImage methodsFor: 'serializing' stamp: 'mab 4/12/2008 14:25'!
writeHeaderTo: aByteStream
	aByteStream littleEndianWord: 16r4242.
	aByteStream littleEndianWord: self objects size.! !

!NXTImage methodsFor: 'private' stamp: 'mab 6/2/2008 18:04'!
writeImageToStream: aByteStream
	self writeHeaderTo: aByteStream.
	self writeSpecialObjectsTo: aByteStream.
	self writeObjectsTo: aByteStream.! !

!NXTImage methodsFor: 'serializing' stamp: 'mab 9/8/2008 13:49'!
writeObjectsTo: aByteStream
	self objects do: [ :each | 
		each writeOn: aByteStream withImage: self.
		aByteStream position odd ifTrue: [ "padding"
			paddings := paddings + 1.
			aByteStream nextPut: 0 ]].! !

!NXTImage methodsFor: 'serializing' stamp: 'mab 7/21/2008 17:10'!
writeSpecialObjectsTo: aByteStream
	(self specialObjects at: #runSymbol) 
		writeAsReferenceOn: aByteStream 
		within: self.
	self class specialObjects do: [ :objectToClass |
		(self specialObjectAt: objectToClass key) 
			writeAsReferenceOn: aByteStream within: self ].
	self class specialClasses do: [ :class |
		(self classAt: class)
			writeAsReferenceOn: aByteStream within: self ].! !

!NXTImage methodsFor: 'serializing' stamp: 'mab 6/2/2008 19:15'!
writeToStream: aByteStream
	self includeDependentObjects.
	self finished: true.
	self mapper: (NXTObjectMapper on: self objects).
	self writeImageToStream: aByteStream.! !

Object subclass: #NXTImageBuilder
	instanceVariableNames: 'image'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTImageBuilder class methodsFor: 'as yet unclassified' stamp: 'mab 2/20/2008 02:52'!
standardCategories
	^ #('NXTalk-Kernel' 'NXTalk-Collections')! !

!NXTImageBuilder methodsFor: 'as yet unclassified' stamp: 'mab 6/2/2008 17:17'!
helloWorldImageOn: aByteStream
	self image: NXTImage new.
	self image specialObjects at: #runSymbol put: (self image symbolAt: #run).
	self image writeToStream: aByteStream.

! !

!NXTImageBuilder methodsFor: 'accessing' stamp: 'mab 2/20/2008 02:50'!
image
	^ image! !

!NXTImageBuilder methodsFor: 'accessing' stamp: 'mab 2/20/2008 02:50'!
image: anObject
	image := anObject! !

Object subclass: #NXTImageProxy
	instanceVariableNames: 'classes classMapping knownClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTImageProxy methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 17:34'!
addObject: anObject
	"No need to do this here"! !

!NXTImageProxy methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 18:14'!
classAt: aClassName
	| metaclassName newClass |
	metaclassName := (aClassName, ' class') asSymbol.
	(self knownClasses includes: aClassName) ifTrue: [
		newClass := NXTClassProxy for: aClassName asNXTObject.
		self classMapping 
			at: newClass 
			put: (NXTClassProxy for: metaclassName asNXTObject).
		^  newClass ].
	^ classes at: aClassName ifAbsent: [ 
		newClass := classes at: aClassName put: NXTClass new.
		NXTClassCompiler new
			image: self;
			compile: (Smalltalk at: aClassName) into: newClass.
		newClass ]! !

!NXTImageProxy methodsFor: 'accessing' stamp: 'mab 8/19/2008 17:22'!
classMapping
	^ classMapping! !

!NXTImageProxy methodsFor: 'accessing' stamp: 'mab 8/19/2008 17:22'!
classMapping: anObject
	classMapping := anObject! !

!NXTImageProxy methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 18:13'!
initialize
	classMapping := Dictionary new.
	classes := Dictionary new.! !

!NXTImageProxy methodsFor: 'accessing' stamp: 'mab 8/19/2008 17:19'!
knownClasses
	^ knownClasses! !

!NXTImageProxy methodsFor: 'accessing' stamp: 'mab 8/19/2008 17:19'!
knownClasses: anObject
	knownClasses := anObject! !

!NXTImageProxy methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 17:35'!
symbolAt: aSymbol
	"No need to return always the same symbol, as it will be written to a stream"
	^ aSymbol asNXTObject! !

Object subclass: #NXTObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

NXTObject subclass: #NXTBoolean
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTBoolean methodsFor: 'as yet unclassified' stamp: 'mab 5/20/2008 14:20'!
ifFalse: falseBlock ifTrue: trueBlock
	^ self ifTrue: trueBlock ifFalse: falseBlock! !

NXTBoolean subclass: #NXTFalse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTFalse methodsFor: 'as yet unclassified' stamp: 'mab 5/7/2008 17:28'!
& aBoolean
	^ self! !

!NXTFalse methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 14:19'!
and: otherBlock
	^ false! !

!NXTFalse methodsFor: 'as yet unclassified' stamp: 'mab 4/28/2008 23:16'!
ifFalse: aBlock
	^ aBlock value! !

!NXTFalse methodsFor: 'as yet unclassified' stamp: 'mab 4/28/2008 23:16'!
ifTrue: aBlock
	^ nil! !

!NXTFalse methodsFor: 'as yet unclassified' stamp: 'mab 5/20/2008 14:19'!
ifTrue: trueBlock ifFalse: falseBlock
	^ falseBlock value! !

!NXTFalse methodsFor: 'as yet unclassified' stamp: 'mab 5/7/2008 17:28'!
not
	^ true! !

!NXTFalse methodsFor: 'as yet unclassified' stamp: 'mab 6/3/2008 11:11'!
or: alternativeBlock
	^ alternativeBlock value! !

NXTBoolean subclass: #NXTTrue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTTrue methodsFor: 'as yet unclassified' stamp: 'mab 5/7/2008 17:29'!
& aBoolean
	^ aBoolean! !

!NXTTrue methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 14:18'!
and: otherBlock
	^ otherBlock value! !

!NXTTrue methodsFor: 'as yet unclassified' stamp: 'mab 4/28/2008 23:17'!
ifFalse: aBlock
	^ nil! !

!NXTTrue methodsFor: 'as yet unclassified' stamp: 'mab 4/28/2008 23:17'!
ifTrue: aBlock
	^ aBlock value! !

!NXTTrue methodsFor: 'as yet unclassified' stamp: 'mab 5/20/2008 14:19'!
ifTrue: trueBlock ifFalse: falseBlock
	^ trueBlock value! !

!NXTTrue methodsFor: 'as yet unclassified' stamp: 'mab 5/7/2008 17:28'!
not
	^ false! !

!NXTTrue methodsFor: 'as yet unclassified' stamp: 'mab 6/3/2008 11:11'!
or: alternativeBlock
	^ self! !

NXTObject subclass: #NXTButton
	instanceVariableNames: 'number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Hardware'!

NXTButton subclass: #NXTAnyButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Hardware'!

!NXTAnyButton methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 19:08'!
isPressed
	^ self class buttonRead ~= self class noneButton! !

!NXTButton class methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 17:29'!
buttonRead
	<NXTPrimitive: 6>! !

!NXTButton class methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 18:35'!
enter
	^ self new
		number: self enterButton! !

!NXTButton class methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 17:47'!
enterButton
	^ 1! !

!NXTButton class methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 18:35'!
exit
	^ self new
		number: self exitButton! !

!NXTButton class methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 17:47'!
exitButton
	^ 2! !

!NXTButton class methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 18:35'!
left
	^ self new
		number: self leftButton! !

!NXTButton class methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 17:47'!
leftButton
	^ 3! !

!NXTButton class methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 19:08'!
noneButton
	^ 0! !

!NXTButton class methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 18:35'!
right
	^ self new
		number: self rightButton! !

!NXTButton class methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 17:48'!
rightButton
	^ 4! !

!NXTButton class methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 14:42'!
waitFor: aButtonNumber
	[ self buttonRead = aButtonNumber ] whileFalse: [].
	^ aButtonNumber! !

!NXTButton class methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 15:21'!
waitForAnyKey
	[ self buttonRead = 0] whileTrue.
	^ self buttonRead! !

!NXTButton methodsFor: 'testing' stamp: 'mab 7/22/2008 18:37'!
ifPressed: aBlock
	self isPressed ifTrue: [ ^ aBlock value ]! !

!NXTButton methodsFor: 'testing' stamp: 'mab 7/22/2008 18:36'!
isPressed
	^ self class buttonRead == self number! !

!NXTButton methodsFor: 'accessing' stamp: 'mab 7/22/2008 18:34'!
number
	^ number! !

!NXTButton methodsFor: 'accessing' stamp: 'mab 7/22/2008 18:34'!
number: anObject
	number := anObject! !

!NXTButton methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 14:42'!
waitFor
	self class waitFor: self number! !

NXTObject subclass: #NXTButtonContainer
	instanceVariableNames: 'left right enter exit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Hardware'!

!NXTButtonContainer methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 14:26'!
enter
	^ enter! !

!NXTButtonContainer methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 14:26'!
exit
	^ exit! !

!NXTButtonContainer methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 15:24'!
initialize
	enter := NXTButton enter.
	exit := NXTButton exit.
	left := NXTButton left.
	right := NXTButton right.! !

!NXTButtonContainer methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 14:27'!
left
	^ left! !

!NXTButtonContainer methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 14:27'!
right
	^ right! !

!NXTButtonContainer methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 15:25'!
waitForAny
	| key |
	key := NXTButton waitForAnyKey.
	NXTTimer waitFor: 1.
	key = self enter number ifTrue: [ ^ self enter ].
	key = self exit number ifTrue: [ ^ self exit ].
	key = self left number ifTrue: [ ^ self left ].
	key = self right number ifTrue: [ ^ self right ].
	self error: 'Unknown key!!'.! !

NXTObject subclass: #NXTClass
	instanceVariableNames: 'methodDictionary superclass name format instVarNames subclasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 7/14/2008 15:57'!
allInstances 
	"Answer a collection of all current instances of the receiver."

	| all |
	all := NXTOrderedCollection new.
	self allInstancesDo: [:x | x == all ifFalse: [all add: x]].
	^ all asArray
! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 7/14/2008 16:11'!
allInstancesDo: aBlock 
	"Evaluate the argument, aBlock, for each of the current instances of the 
	receiver.
	
	Because aBlock might change the class of inst (for example, using become:),
	it is essential to compute next before aBlock value: inst."
	| inst next |
	self ==  NXTUndefinedObject ifTrue: [^ aBlock value: nil].
	inst := self firstInstance.
	[ inst == nil ] whileFalse: [
		next := inst nextInstance.
		aBlock value: inst.
		inst := next]! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 7/24/2008 16:48'!
allSubInstances 
	"Answer a list of all current instances of the receiver and all of its subclasses."
	| aCollection |
	aCollection := NXTOrderedCollection new.
	self allSubInstancesDo:
		[:x | x == aCollection ifFalse: [aCollection add: x]].
	^ aCollection! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 7/24/2008 16:48'!
allSubInstancesDo: aBlock 
	"Evaluate the argument, aBlock, for each of the current instances of the 
	receiver and all its subclasses."

	self allInstancesDo: aBlock.
	self allSubclassesDo: [:sub | sub allInstancesDo: aBlock]! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 8/12/2008 17:58'!
allSubclasses
	| classes |
	classes := NXTOrderedCollection new.
	self allSubclassesDo: [ :class |
		classes add: class ].
	^ classes! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 7/24/2008 16:49'!
allSubclassesDo: aBlock 
	"Evaluate the argument, aBlock, for each of the receiver's subclasses."

	self subclassesDo: 
		[:cl | 
		aBlock value: cl.
		cl allSubclassesDo: aBlock]! !

!NXTClass methodsFor: 'nxt-exclude' stamp: 'mab 7/25/2008 14:10'!
asSqueakObject
	^ Smalltalk at: self name asSqueakObject! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 5/29/2008 15:55'!
basicNew
	<NXTPrimitive: 15>! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 5/29/2008 16:56'!
basicNew: sizeRequested
	<NXTPrimitive: 16>! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 7/14/2008 16:12'!
firstInstance
	<NXTPrimitive: 28>! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 6/5/2008 17:06'!
format
	^ format! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 6/5/2008 17:06'!
format: anObject
	format := anObject! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 14:23'!
inheritsFrom: aClass 
	"Answer whether the argument, aClass, is on the receiver's superclass 
	chain."

	| aSuperclass |
	aSuperclass := superclass.
	[aSuperclass == nil]
		whileFalse: 
			[aSuperclass == aClass ifTrue: [^true].
			aSuperclass := aSuperclass superclass].
	^false! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 9/1/2008 17:48'!
instSize
	^ format >> 2! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 5/21/2008 14:47'!
instVarNames
	^ instVarNames! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 5/21/2008 14:47'!
instVarNames: anObject
	instVarNames := anObject! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 5/22/2008 16:35'!
isClass
	^ true! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 5/21/2008 14:46'!
methodDictionary
	^ methodDictionary! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 5/21/2008 14:46'!
methodDictionary: anObject
	methodDictionary := anObject! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 5/29/2008 16:06'!
name
	^ name! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 5/29/2008 16:06'!
name: aSymbol
	^ name := aSymbol! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 5/29/2008 15:56'!
new
	^ self basicNew initialize! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 5/29/2008 16:48'!
new: sizeRequested 
	^ (self basicNew: sizeRequested) initialize  ! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 6/6/2008 15:37'!
selectors
	| c |
	c := OrderedCollection new.
	self methodDictionary pairsDo: [ :selector :method |
		c add: selector ].
	^ c! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 14:31'!
subclasses
	^ subclasses! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 14:23'!
subclasses: array
	subclasses := array! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 7/24/2008 16:50'!
subclassesDo: aBlock
	"Evaluate the argument, aBlock, for each of the receiver's immediate subclasses."
	^self subclasses do: aBlock! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 5/21/2008 14:45'!
superclass
	^ superclass! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 5/21/2008 14:45'!
superclass: anObject
	superclass := anObject! !

NXTClass subclass: #NXTMetaclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTMetaclass methodsFor: 'nxt-exclude' stamp: 'mab 7/25/2008 14:09'!
asSqueakObject
	^ (Smalltalk at: (name asSqueakObject allButLast: 6) asSymbol) class! !

!NXTMetaclass methodsFor: 'as yet unclassified' stamp: 'mab 5/21/2008 16:34'!
isMeta
	^ true! !

NXTObject subclass: #NXTClassProxy
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTClassProxy class methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 17:30'!
for: aName
	^ self new name: aName! !

!NXTClassProxy methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 17:30'!
name
	^ name! !

!NXTClassProxy methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 17:30'!
name: anObject
	name := anObject! !

NXTObject subclass: #NXTCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

!NXTCollection class methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 14:37'!
withAll: aCollection
	"Create a new collection containing all the elements from aCollection."

	^ (self new: aCollection size)
		addAll: aCollection;
		yourself! !

!NXTCollection methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 15:16'!
addAll: aCollection
	aCollection do: [ :each | self add: each ]! !

!NXTCollection methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 14:06'!
anySatisfy: aBlock
	"Evaluate aBlock with the elements of the receiver.
	If aBlock returns true for any element return true.
	Otherwise return false."

	self do: [:each | (aBlock value: each) ifTrue: [^ true]].
	^ false! !

!NXTCollection methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 17:06'!
asArray
	"Answer an Array whose elements are the elements of the receiver.
	Implementation note: Cannot use ''Array withAll: self'' as that only
	works for SequenceableCollections which support the replacement 
	primitive."

	| array index |
	array := NXTArray new: self size.
	index := 0.
	self do: [:each | array at: (index := index + 1) put: each].
	^ array! !

!NXTCollection methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 14:26'!
asSet
	"Answer a Set whose elements are the unique elements of the receiver."

	^ NXTSet withAll: self! !

!NXTCollection methodsFor: 'as yet unclassified' stamp: 'mab 8/12/2008 18:01'!
collect: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Collect the resulting values into a collection like the receiver. Answer  
	the new collection."

	| newCollection |
	newCollection := self species new.
	self do: [:each | newCollection add: (aBlock value: each)].
	^ newCollection! !

!NXTCollection methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 13:57'!
doWithIndex: binaryBlock
	| index |
	index := 0.
	self do: [:elt | binaryBlock value: elt value: (index := index + 1)].! !

!NXTCollection methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 14:06'!
includes: anObject 
	"Answer whether anObject is one of the receiver's elements."

	^ self anySatisfy: [:each | each = anObject]! !

!NXTCollection methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 19:35'!
isEmpty
	"Answer whether the receiver contains any elements."

	^self size = 0! !

!NXTCollection methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 14:35'!
reject: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Collect into a new collection like the receiver only those elements for 
	which aBlock evaluates to false. Answer the new collection."

	^self select: [:element | (aBlock value: element) == false]! !

!NXTCollection methodsFor: 'as yet unclassified' stamp: 'mab 6/9/2008 15:09'!
select: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Collect into a new collection like the receiver, only those elements for 
	which aBlock evaluates to true. Answer the new collection."

	| newCollection |
	newCollection := self species new.
	self do: [:each | (aBlock value: each) ifTrue: [ newCollection add: each]].
	^newCollection! !

NXTCollection subclass: #NXTSequenceableCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

NXTSequenceableCollection variableSubclass: #NXTArray
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

!NXTArray class methodsFor: 'as yet unclassified' stamp: 'mab 7/14/2008 19:24'!
with: anObject 
	"Answer a new instance of me, containing only anObject."

	| newCollection |
	newCollection := self new: 1.
	newCollection at: 1 put: anObject.
	^newCollection! !

!NXTArray class methodsFor: 'as yet unclassified' stamp: 'mab 7/21/2008 14:48'!
with: anObject1 with: anObject2
	"Answer a new instance of me, containing only anObject."

	| newCollection |
	newCollection := self new: 2.
	newCollection at: 1 put: anObject1.
	newCollection at: 2 put: anObject2.
	^newCollection! !

!NXTArray class methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 18:09'!
with: anObject1 with: anObject2 with: anObject3
	"Answer a new instance of me, containing only anObject."

	| newCollection |
	newCollection := self new: 3.
	newCollection at: 1 put: anObject1.
	newCollection at: 2 put: anObject2.
	newCollection at: 3 put: anObject3.
	^newCollection! !

!NXTArray methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 14:37'!
asOrderedCollection
	^ NXTOrderedCollection withAll: self! !

!NXTArray methodsFor: 'nxt-exclude' stamp: 'mab 5/29/2008 11:46'!
computeSize
	^ self size! !

!NXTArray methodsFor: 'nxt-exclude' stamp: 'mab 5/29/2008 11:45'!
instanceVariables
	| c |
	c := OrderedCollection new.
	1 to: self size do: [ :index |
		c add: (self at: index) ].
	^ c! !

!NXTArray methodsFor: 'as yet unclassified' stamp: 'mab 6/2/2008 14:58'!
size
	<NXTPrimitive: 17>
	^ super size! !

NXTSequenceableCollection variableSubclass: #NXTOrderedCollection
	instanceVariableNames: 'array firstIndex lastIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

!NXTOrderedCollection class methodsFor: 'instance creation' stamp: 'mab 5/29/2008 15:59'!
new
	^ self new: 10! !

!NXTOrderedCollection class methodsFor: 'instance creation' stamp: 'mab 5/29/2008 16:00'!
new: anInteger 
	^ self basicNew setCollection: (NXTArray new: anInteger)! !

!NXTOrderedCollection class methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 15:17'!
withAll: aCollection
	"Create a new collection containing all the elements from aCollection."

	^ (self new: aCollection size) addAll: aCollection! !

!NXTOrderedCollection methodsFor: 'adding' stamp: 'mab 6/9/2008 15:30'!
add: newObject
	^self addLast: newObject! !

!NXTOrderedCollection methodsFor: 'adding' stamp: 'mab 5/29/2008 15:48'!
addLast: newObject 
	"Add newObject to the end of the receiver. Answer newObject."

	lastIndex = array size ifTrue: [self makeRoomAtLast].
	lastIndex := lastIndex + 1.
	array at: lastIndex put: newObject.
	^ newObject! !

!NXTOrderedCollection methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 15:46'!
at: anInteger 
	"Answer my element at index anInteger. at: is used by a knowledgeable
	client to access an existing element"
	
	(anInteger < 1 or: [anInteger + firstIndex - 1 > lastIndex])
		ifTrue: [self errorNoSuchElement]
		ifFalse: [^ array at: anInteger + firstIndex - 1]! !

!NXTOrderedCollection methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 15:36'!
at: anInteger put: anObject 
	"Put anObject at element index anInteger. at:put: cannot be used to
	append, front or back, to an ordered collection; it is used by a
	knowledgeable client to replace an element."

	| index |
	index := anInteger asInteger.
	(index < 1 or: [index + firstIndex - 1 > lastIndex])
		ifTrue: [self errorNoSuchElement]
		ifFalse: [^array at: index + firstIndex - 1 put: anObject]! !

!NXTOrderedCollection methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 10:02'!
collect: aBlock 
	"Evaluate aBlock with each of my elements as the argument. Collect the 
	resulting values into a collection that is like me. Answer the new 
	collection. Override superclass in order to use addLast:, not at:put:."

	| newCollection |
	newCollection := self species new: self size.
	firstIndex to: lastIndex do:
		[:index |
		newCollection addLast: (aBlock value: (array at: index))].
	^ newCollection! !

!NXTOrderedCollection methodsFor: 'as yet unclassified' stamp: 'mab 8/20/2008 16:10'!
errorNoSuchElement
	self error: 'attempt to index non-existent element in an ordered collection'! !

!NXTOrderedCollection methodsFor: 'adding' stamp: 'mab 5/29/2008 16:00'!
grow
	"Become larger. Typically, a subclass has to override this if the subclass
	adds instance variables."
	| newArray |
	newArray := NXTArray new: self size + self growSize.
	newArray replaceFrom: 1 to: array size with: array startingAt: 1.
	array := newArray! !

!NXTOrderedCollection methodsFor: 'adding' stamp: 'mab 5/29/2008 15:48'!
growSize
	^ array size max: 2! !

!NXTOrderedCollection methodsFor: 'adding' stamp: 'mab 5/29/2008 15:48'!
makeRoomAtLast
	| newLast delta |
	newLast := self size.
	array size - self size = 0 ifTrue: [self grow].
	(delta := firstIndex - 1) = 0 ifTrue: [^ self].
	"we might be here under false premises or grow did the job for us"
	1 to: newLast do:
		[:index |
		array at: index put: (array at: index + delta).
		array at: index + delta put: nil].
	firstIndex := 1.
	lastIndex := newLast! !

!NXTOrderedCollection methodsFor: 'private' stamp: 'mab 5/29/2008 15:53'!
reset
	firstIndex := array size // 3 max: 1.
	lastIndex := firstIndex - 1! !

!NXTOrderedCollection methodsFor: 'private' stamp: 'mab 5/29/2008 15:53'!
setCollection: anArray
	array := anArray.
	self reset! !

!NXTOrderedCollection methodsFor: 'as yet unclassified' stamp: 'mab 6/6/2008 15:52'!
size
	"Answer how many elements the receiver contains."

	^ lastIndex - firstIndex + 1! !

!NXTSequenceableCollection class methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 14:39'!
withAll: aCollection
	"Create a new collection containing all the elements from aCollection."

	^ (self new: aCollection size) replaceFrom: 1 to: aCollection size with: aCollection! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 6/6/2008 16:06'!
, other
	| oldSize newSize c |
	newSize := self size + other size.
	c := self class new: newSize.
	1 to: self size do: [ :index | c at: index put: (self at: index) ].
	oldSize := self size.
	1 to: other size do: [ :index | c at: index + oldSize put: (other at: index) ].
	^ c
	! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 6/6/2008 16:30'!
= otherCollection 
	"Answer true if the receiver is equivalent to the otherCollection.
	First test for identity, then rule out different species and sizes of
	collections. As a last resort, examine each element of the receiver
	and the otherCollection."

	self == otherCollection ifTrue: [^ true].
	self species == otherCollection species ifFalse: [^ false].
	^ self hasEqualElements: otherCollection! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 14:56'!
allButFirst: n
	"Answer a copy of the receiver containing all but the first n
	elements. Raise an error if there are not enough elements."

	^ self copyFrom: n + 1 to: self size! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 7/24/2008 16:59'!
asArray
	"Answer an Array whose elements are the elements of the receiver."

	^ NXTArray withAll: self! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 15:42'!
atAllPut: anObject 
	"Put anObject at every one of the receiver's indices."

	| size |
	(size := self size) > 26 "first method faster from 27 accesses and on"
		ifTrue: [self from: 1 to: size put: anObject]
		ifFalse: [1 to: size do: [:index | self at: index put: anObject]]! !

!NXTSequenceableCollection methodsFor: 'comparing' stamp: 'mab 7/25/2008 19:33'!
beginsWith: aSequenceableCollection

	(aSequenceableCollection isEmpty or: [self size < aSequenceableCollection size]) ifTrue: [^false].
	aSequenceableCollection withIndexDo: [:each :index | (self at: index) ~= each ifTrue: [^false]].
	^true! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 8/12/2008 18:41'!
collect: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Collect the resulting values into a collection like the receiver. Answer  
	the new collection."

	| newCollection |
	newCollection := self species new: self size.
	1 to: self size do:
		[:index |
		newCollection at: index put: (aBlock value: (self at: index))].
	^ newCollection! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 6/6/2008 16:14'!
copyFrom: start to: stop 
	"Answer a copy of a subset of the receiver, starting from element at 
	index start until element at index stop."

	| newSize |
	newSize := stop - start + 1.
	^(self species new: newSize)
		replaceFrom: 1
		to: newSize
		with: self
		startingAt: start! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 6/5/2008 14:36'!
do: aBlock 
	"Refer to the comment in Collection|do:."
	1 to: self size do:
		[:index | aBlock value: (self at: index)]! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 17:43'!
doWithIndex: elementAndIndexBlock
	"Use the new version with consistent naming"
	^ self withIndexDo: elementAndIndexBlock! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 15:21'!
first
	^ self at: 1! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 6/6/2008 16:14'!
first: n
	"Answer the first n elements of the receiver.
	Raise an error if there are not enough elements."

	^ self copyFrom: 1 to: n! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 15:45'!
from: startIndex to: endIndex put: anObject
	"Put anObject in all indexes between startIndex 
	and endIndex. Very fast. Faster than to:do: for
	more than 26 positions. Answer anObject"

	| written toWrite thisWrite |

	startIndex > endIndex ifTrue: [^self].
	self at: startIndex put: anObject.
	written := 1.
	toWrite := endIndex - startIndex + 1.
	[written < toWrite] whileTrue:
		[
			thisWrite := written min: toWrite - written.
			self 
				replaceFrom: startIndex + written
				to: startIndex + written + thisWrite - 1
				with: self startingAt: startIndex.
			written := written + thisWrite
		].
	^anObject! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 6/6/2008 16:30'!
hasEqualElements: otherCollection
	"Answer whether the receiver's size is the same as otherCollection's
	size, and each of the receiver's elements equal the corresponding 
	element of otherCollection.
	This should probably replace the current definition of #= ."

	| size |
	"(otherCollection isKindOf: SequenceableCollection) ifFalse: [^ false]."
	(size := self size) = otherCollection size ifFalse: [^ false].
	1 to: size do:
		[:index |
		(self at: index) = (otherCollection at: index) ifFalse: [^ false]].
	^ true! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 7/14/2008 19:25'!
indexOf: anElement
	"Answer the index of the first occurence of anElement within the  
	receiver. If the receiver does not contain anElement, answer 0."

	^ self indexOf: anElement ifAbsent: [0]! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 7/14/2008 19:25'!
indexOf: anElement ifAbsent: exceptionBlock
	"Answer the index of the first occurence of anElement within the  
	receiver. If the receiver does not contain anElement, answer the 
	result of evaluating the argument, exceptionBlock."

	^ self indexOf: anElement startingAt: 1 ifAbsent: exceptionBlock! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 7/14/2008 19:25'!
indexOf: anElement startingAt: start ifAbsent: exceptionBlock
	"Answer the index of the first occurence of anElement after start
	within the receiver. If the receiver does not contain anElement, 
	answer the 	result of evaluating the argument, exceptionBlock."

	start to: self size do:
		[:index |
		(self at: index) = anElement ifTrue: [^ index]].
	^ exceptionBlock value! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 8/12/2008 18:43'!
last
	"Answer the last element of the receiver"

	^ self at: self size! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 6/6/2008 15:39'!
pairsDo: aBlock 
	"Evaluate aBlock with my elements taken two at a time.  If there's an odd number of items, ignore the last one.  Allows use of a flattened array for things that naturally group into pairs.  See also pairsCollect:"

	1 to: self size // 2 do:
		[:index | aBlock value: (self at: 2 * index - 1) value: (self at: 2 * index)]! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 6/5/2008 16:14'!
replaceFrom: start to: stop with: replacement 
	"This destructively replaces elements from start to stop in the receiver. 
	Answer the receiver itself. Use copyReplaceFrom:to:with: for 
	insertion/deletion which may alter the size of the result."

	replacement size = (stop - start + 1)
		ifFalse: [self error: 'Size of replacement doesnt match'].
	^self replaceFrom: start to: stop with: replacement startingAt: 1! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 5/29/2008 15:50'!
replaceFrom: start to: stop with: replacement startingAt: repStart 
	"This destructively replaces elements from start to stop in the receiver 
	starting at index, repStart, in the sequenceable collection, 
	replacementCollection. Answer the receiver. No range checks are 
	performed."

	| index repOff |
	repOff := repStart - start.
	index := start - 1.
	[(index := index + 1) <= stop]
		whileTrue: [self at: index put: (replacement at: repOff + index)]! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 6/6/2008 15:12'!
startsWith: start 
	| comp |
	self size < start size ifTrue: [^ false].
	comp := true.
	(self first: start size) with: start
		do: [:ea :ea2 | ea = ea2 ifFalse: [comp := false]].
	^ comp! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 6/6/2008 15:12'!
with: otherCollection do: twoArgBlock 
	"Evaluate twoArgBlock with corresponding elements from this collection and otherCollection."
	otherCollection size = self size ifFalse: [self error: 'otherCollection must be the same size'].
	1 to: self size do:
		[:index |
		twoArgBlock value: (self at: index)
				value: (otherCollection at: index)]! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 17:42'!
withIndexDo: elementAndIndexBlock 
	"Just like with:do: except that the iteration index supplies the second argument to the block."
	1 to: self size do:
		[:index |
		elementAndIndexBlock
			value: (self at: index)
			value: index]! !

NXTSequenceableCollection variableByteSubclass: #NXTString
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

!NXTString class methodsFor: 'as yet unclassified' stamp: 'mab 6/9/2008 16:38'!
cr
	| string |
	string := self new: 1.
	string at: 1 put: 10.
	^ string! !

!NXTString class methodsFor: 'nxt-exclude' stamp: 'mab 6/5/2008 17:12'!
elementSize
	^ 1! !

!NXTString class methodsFor: 'as yet unclassified' stamp: 'mab 7/14/2008 17:12'!
printString: aString
	<NXTPrimitive: 0>
	Transcript show: aString; cr.! !

!NXTString methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 15:51'!
= other
	other isString ifFalse: [ ^ false ].
	self size = other size ifFalse: [ ^ false ].
	1 to: self size do: [ :index |
		(self at: index) = (other at: index) ifFalse: [ ^ false ]].
	^ true
	! !

!NXTString methodsFor: 'nxt-exclude' stamp: 'mab 7/15/2008 10:47'!
asByteArray
	^ self! !

!NXTString methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 10:56'!
asString
	^ self! !

!NXTString methodsFor: 'as yet unclassified' stamp: 'mab 7/16/2008 14:41'!
asSymbol
	^ NXTSymbol intern: self! !

!NXTString methodsFor: 'nxt-exclude' stamp: 'mab 9/10/2008 14:34'!
at: index
	<primitive: 63>
	<NXTPrimitive: 20>! !

!NXTString methodsFor: 'nxt-exclude' stamp: 'mab 9/10/2008 14:33'!
at: index put: aCharacter
	<primitive: 64>
	<NXTPrimitive: 21>! !

!NXTString methodsFor: 'nxt-exclude' stamp: 'mab 6/5/2008 17:17'!
computeSize
	^ self size! !

!NXTString methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 15:57'!
isString
	^ true! !

!NXTString methodsFor: 'as yet unclassified' stamp: 'mab 7/14/2008 17:12'!
print
	self class printString: self! !

!NXTString methodsFor: 'as yet unclassified' stamp: 'mab 7/16/2008 17:38'!
printNl
	(self, self class cr) print! !

!NXTString methodsFor: 'nxt-exclude' stamp: 'mab 6/6/2008 14:36'!
printOn: aStream
	aStream nextPutAll: 'an NXTString('''.
	aStream nextPutAll: self.
	aStream nextPutAll: ''')'.! !

!NXTString methodsFor: 'nxt-exclude' stamp: 'mab 7/21/2008 18:38'!
writeDataOn: aByteStream withImage: image
	1 to: self size do: [ :index |
		aByteStream nextPut: (self at: index) asInteger ].! !

NXTString variableByteSubclass: #NXTSymbol
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

!NXTSymbol class methodsFor: 'as yet unclassified' stamp: 'mab 7/16/2008 14:42'!
intern: aStringOrSymbol
	<NXTPrimitive: 30>! !

!NXTSymbol methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 15:48'!
= aSymbol
	"Compare the receiver and aSymbol." 
	self == aSymbol ifTrue: [^ true].
	self class == aSymbol class ifTrue: [^ false].
	"Use String comparison otherwise"
	^ super = aSymbol! !

!NXTSymbol methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 19:50'!
asMutator
	^ (self, ':') asSymbol! !

!NXTSymbol methodsFor: 'nxt-exclude' stamp: 'mab 7/25/2008 11:18'!
asSqueakObject
	^ (String withAll: self) asSymbol! !

!NXTSymbol methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 16:07'!
asString
	| string |
	string := String new: self size.
	string replaceFrom: 1 to: self size with: self.
	^ string! !

!NXTSymbol methodsFor: 'testing' stamp: 'mab 7/25/2008 19:16'!
isSymbol
	^ true! !

!NXTSymbol methodsFor: 'as yet unclassified' stamp: 'mab 7/14/2008 17:18'!
print
	'#' print. self class printString: self.! !

!NXTSymbol methodsFor: 'nxt-exclude' stamp: 'mab 6/6/2008 14:36'!
printOn: aStream
	aStream nextPutAll: 'an NXTSymbol(#'.
	aStream nextPutAll: self.
	aStream nextPut: $).! !

NXTCollection subclass: #NXTSet
	instanceVariableNames: 'tally array'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

!NXTSet commentStamp: 'mab 8/15/2008 14:47' prior: 0!
Methods taken from Ian Piumarta's idST (object/st80/Set.st).!

NXTSet subclass: #NXTDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

!NXTDictionary commentStamp: 'mab 8/15/2008 15:09' prior: 0!
Methods taken from Ian Piumarta's idST (object/st80/Dictionary.st).!

!NXTDictionary class methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 16:44'!
new
	^ super new! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 17:08'!
= aDictionary
	aDictionary isDictionary ifFalse: [^false].
	self size = aDictionary size ifFalse: [^false].
	self associationsDo: [:assoc|
	(aDictionary at: assoc key ifAbsent: [^false]) = assoc value
		ifFalse: [^false]].
	^true! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:56'!
add: anAssociation
	| index element |
	index := self findElementOrNil: anAssociation key.
	element := array at: index.
	element == nil
		ifTrue: [self atNewIndex: index put: anAssociation]
		ifFalse: [element value: anAssociation value].
	^ anAssociation! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:57'!
addAll: aDictionary
	aDictionary == self ifFalse: [aDictionary associationsDo: [:assoc | self add: assoc]].
	^aDictionary.! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:49'!
associationAt: key
	^self associationAt: key ifAbsent: [self errorKeyNotFound]! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:49'!
associationAt: key ifAbsent: aBlock
	"Answer the association with the given key.  If key is not found,
	return the result of evaluating aBlock."
	| index assoc |
	index := self findElementOrNil: key.
	assoc := array at: index.
	^nil == assoc
		ifTrue:  [aBlock value]
		ifFalse: [assoc]! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:57'!
associationsDo: aBlock
	super do: aBlock! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 14:17'!
associationsSelect: aBlock 
	"Evaluate aBlock with each of my associations as the argument. Collect
	into a new dictionary, only those associations for which aBlock evaluates
	to true."

	| newCollection |
	newCollection := self species new.
	self associationsDo: 
		[:each | 
		(aBlock value: each) ifTrue: [newCollection add: each]].
	^newCollection! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 13:42'!
at: key
	"Answer the value associated with the key."
	^self at: key ifAbsent: [self errorKeyNotFound]! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:52'!
at: key ifAbsent: aBlock
	"Answer the value associated with the key or, if key isn't found,
	answer the result of evaluating aBlock."
	| assoc |
	assoc := array at: (self findElementOrNil: key).
	^nil == assoc
		ifTrue:  [aBlock value]
		ifFalse: [assoc value]! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 13:48'!
at: key put: anObject 
	"Set the value at key to be anObject.  If key is not found, create a
	new entry for key and set is value to anObject. Answer anObject."
	| index assoc |
	index := self findElementOrNil: key.
	assoc := array at: index.
	assoc
		ifNil: [self atNewIndex: index put: (NXTAssociation key: key value: anObject)]
		ifNotNil: [assoc value: anObject].
	^ anObject! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:38'!
collect: aBlock 
	"Evaluate aBlock with each of my values as the argument.  Collect the
	resulting values into a collection that is like me. Answer with the new
	collection."
	| newCollection |
	newCollection := NXTOrderedCollection new: self size.
	self do: [:each | newCollection add: (aBlock value: each)].
	^ newCollection! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:58'!
do: aBlock
	super do: [:assoc | aBlock value: assoc value]! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:01'!
errorKeyNotFound
	self error: 'key not found'! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:01'!
errorValueNotFound
	self error: 'value not found'! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 15:07'!
includesAssociation: anAssociation
  ^ (self   
      associationAt: anAssociation key
      ifAbsent: [ ^ false ]) value = anAssociation value
! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:56'!
includesKey: key
	self at: key ifAbsent: [^false].
	^true! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 16:55'!
isDictionary
	^ true! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:02'!
keyAt: index
	"May be overridden by subclasses so that fixCollisions will work"
	| assoc |
	assoc := array at: index.
	^nil == assoc ifFalse: [assoc key]! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 14:02'!
keyAtValue: value 
	"Answer the key that is the external name for the argument, value. If 
	there is none, answer nil."

	^self keyAtValue: value ifAbsent: [self errorValueNotFound]! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 14:02'!
keyAtValue: value ifAbsent: exceptionBlock
	"Answer the key that is the external name for the argument, value. If 
	there is none, answer the result of evaluating exceptionBlock.
	: Use =, not ==, so stings like 'this' can be found.  Note that MethodDictionary continues to use == so it will be fast."
 
	self associationsDo: 
		[:association | value = association value ifTrue: [^association key]].
	^exceptionBlock value! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:54'!
keys
	| keySet |
	keySet := NXTSet new: self size.
	self keysDo: [:key | keySet add: key].
    ^keySet! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:58'!
keysAndValuesDo: aBlock
	^self associationsDo: [:assoc | aBlock value: assoc key value: assoc value]! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:58'!
keysDo: aBlock
	self associationsDo: [:association | aBlock value: association key]! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:02'!
noCheckAdd: anObject
	array at: (self findElementOrNil: anObject key) put: anObject.
	tally := tally + 1.! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 14:04'!
occurrencesOf: anObject 
	"Answer how many of the receiver's elements are equal to anObject."

	| count |
	count := 0.
	self do: [:each | anObject = each ifTrue: [count := count + 1]].
	^count! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:03'!
rehash	
	| newSelf |
	newSelf := self species new: self size.
	self associationsDo: [:each | newSelf noCheckAdd: each].
	array := newSelf array! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:07'!
removeKey: key
	^self removeKey: key ifAbsent: [self errorKeyNotFound]! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:07'!
removeKey: key ifAbsent: aBlock 
	"Remove key (and its associated value) from the receiver. If key is not in 
	the receiver, answer the result of evaluating aBlock. Otherwise, answer 
	the value externally named by key."
	| index assoc |
	index := self findElementOrNil: key.
	assoc := array at: index.
	assoc == nil ifTrue: [ ^ aBlock value ].
	array at: index put: nil.
	tally := tally - 1.
	self fixCollisionsFrom: index.
	^ assoc value! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:05'!
scanFor: anObject
	"Scan the key array for the first slot containing either a nil
	(indicating an empty slot) or an element that matches
	anObject. Answer the index of that slot or zero if no slot is
	found. This method will be overridden in various subclasses that
	have different interpretations for matching elements."
	| element start finish |
	start := (anObject hash \\ array size) + 1.
	finish := array size.
	"Search from (hash mod size) to the end."
	start to: finish do: [:index |
	((element := array at: index) == nil or: [element key = anObject])
		ifTrue: [^index]].
	"Search from 1 to where we started."
	1 to: start - 1 do: [:index |
		((element := array at: index) == nil or: [element key = anObject])
			ifTrue: [^index]].
	^0! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:59'!
select: aBlock
	"Evaluate aBlock with each of my values as the argument.  Collect into a
	new Dictionary all associations for which aBlock evaluates to true."
	| newCollection |
	newCollection := self species new.
	self associationsDo: [:assoc | (aBlock value: assoc value) ifTrue: [newCollection add: assoc]].
	^newCollection! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:55'!
values	
	| valueArray |
	valueArray := NXTArray new: self size.
	self doWithIndex: [:value :index | valueArray at: index put: value].
	^valueArray! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:00'!
valuesDo: aBlock
	self associationsDo: [:assoc | aBlock value: assoc value]! !

!NXTSet class methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:32'!
new
	^ self new: 2! !

!NXTSet class methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:33'!
new: size
	^ super new initialize: size! !

!NXTSet methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 16:08'!
= aSet
	self == aSet ifTrue: [^ true].	"stop recursion"
	(aSet isKindOf: NXTSet) ifFalse: [^ false].
	self size = aSet size ifFalse: [^ false].
	self do: [:each | (aSet includes: each) ifFalse: [^ false]].
	^ true! !

!NXTSet methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:36'!
add: newObject
	| index |
	newObject isNil ifTrue: [self error: 'Sets cannot meaningfully contain nil as an element'].
	index := self findElementOrNil: newObject.
	(array at: index) isNil ifTrue: [self atNewIndex: index put: newObject].
	^newObject! !

!NXTSet methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 17:03'!
array
	^ array! !

!NXTSet methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:37'!
atNewIndex: index put: anObject
	array at: index put: anObject.
	tally := tally + 1.
	self fullCheck.! !

!NXTSet methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:42'!
do: unaryBlock
	tally = 0 ifFalse: [array do: [:element | element isNil ifFalse: [unaryBlock value: element]]]! !

!NXTSet methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:34'!
findElementOrNil: anObject
	"Answer the index of a first slot containing either a nil
     (indicating an empty slot) or an element that matches the given
     object.  Answer the index of that slot or zero.  Fail if neither
     a match nor an empty slot is found. "
    | index |
    index := self scanFor: anObject.
    index < 0 ifTrue: [self error: 'there is no free space in this Set'].
    ^index! !

!NXTSet methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:41'!
fixCollisionsFrom: index
	"The element at index has been removed and replaced by nil.
	This method moves forward from there, relocating any entries
	that had been placed below due to collisions with this one"
	| length oldIndex newIndex element |
	oldIndex := index.
	length := array size.
	[oldIndex = length
		ifTrue: [oldIndex := 1]
		ifFalse: [oldIndex := oldIndex + 1].
	(element := self keyAt: oldIndex) == nil]
		whileFalse: 
			[newIndex := self findElementOrNil: element.
			oldIndex = newIndex ifFalse: [self swap: oldIndex with: newIndex]].! !

!NXTSet methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:38'!
fullCheck
	"Keep array at least 1/4 free for decent hash behaviour."
	(array size - tally) < (1 max: (array size // 4)) ifTrue: [self grow]! !

!NXTSet methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 17:40'!
grow
	"Grow the elements array and reinsert the old elements."
	| oldElements oldSize |
	oldElements := array.
	oldSize := array size.
	array := NXTArray new: oldSize + self growSize.
	tally := 0.
	oldElements do: [:element | element isNil ifFalse: [self noCheckAdd: element]]! !

!NXTSet methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:38'!
growSize
	^ array size! !

!NXTSet methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:34'!
initialize: size
	tally := 0.
	array := NXTArray new: size.! !

!NXTSet methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:41'!
keyAt: index
	"May be overridden by subclasses so that fixCollisions will work"
	^ array at: index! !

!NXTSet methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:43'!
like: anObject
	| index |
	index := self scanFor: anObject.
	^index < 1 ifFalse: [array at: index]! !

!NXTSet methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:39'!
noCheckAdd: anObject
	array at: (self findElementOrNil: anObject) put: anObject.
	tally := tally + 1.! !

!NXTSet methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:40'!
remove: oldObject ifAbsent: aBlock
	| index |
	index := self findElementOrNil: oldObject.
	(array at: index) == nil ifTrue: [^aBlock value].
	array at: index put: nil.
	tally := tally - 1.
	self fixCollisionsFrom: index.
	^oldObject! !

!NXTSet methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:37'!
scanFor: anObject
	"Scan the array for the first slot containing either a nil
	(indicating an empty slot) or an element that matches anObject.
	Answer the index of that slot or 0 if no slot is found.  This
	method will be overridden in various subtypes that have
	different interpretations for matching elements. "
	| finish start |
	finish := array size.
	start := anObject hash \\ finish + 1.
	"search from (hash mod size) to the end"
	start to: finish do: [:index |
		| element |
		((element := array at: index) isNil or: [element = anObject])
			ifTrue: [^index]].
	"search from start to (hash mod size)"
	1 to: start do: [:index |
		| element |
		((element := array at: index) isNil or: [element = anObject])
			ifTrue: [^index]].
	^0.	"no match AND no empty slot"! !

!NXTSet methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:43'!
size
	^ tally! !

!NXTSet methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:41'!
swap: oneIndex with: otherIndex
	"May be overridden by subclasses so that fixCollisions will work"
	array swap: oneIndex with: otherIndex
! !

NXTObject subclass: #NXTDisplay
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Hardware'!

!NXTDisplay methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 13:28'!
clear
	<NXTPrimitive: 35>! !

!NXTDisplay methodsFor: 'as yet unclassified' stamp: 'mab 7/23/2008 16:25'!
scrolling: on
	<NXTPrimitive: 32>! !

NXTObject subclass: #NXTException
	instanceVariableNames: 'messageText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

NXTException subclass: #NXTError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTException class methodsFor: 'as yet unclassified' stamp: 'mab 9/1/2008 18:32'!
handles: exception
	"Determine whether an exception handler will accept a signaled exception."
	^ exception isKindOf: self! !

!NXTException class methodsFor: 'as yet unclassified' stamp: 'mab 6/9/2008 15:55'!
signal: text
	self new signal: text! !

!NXTException methodsFor: 'accessing' stamp: 'mab 5/21/2008 18:21'!
messageText
	^ messageText! !

!NXTException methodsFor: 'accessing' stamp: 'mab 5/21/2008 18:21'!
messageText: anObject
	messageText := anObject! !

!NXTException methodsFor: 'as yet unclassified' stamp: 'mab 9/1/2008 14:13'!
signal
	"Ask ContextHandlers in the sender chain to handle this signal.  The default is to execute and return my defaultAction."
	^ thisContext nextHandlerContext handleSignal: self! !

!NXTException methodsFor: 'as yet unclassified' stamp: 'mab 6/9/2008 16:14'!
signal: text
	self messageText: text.
	self signal! !

NXTException subclass: #NXTTestFailure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

NXTObject subclass: #NXTFrame
	instanceVariableNames: 'context receiver pc stackPointer numArgs numTemps environment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

NXTFrame subclass: #NXTBlockFrame
	instanceVariableNames: 'block home blub'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTBlockFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/3/2008 19:34'!
doWhileTrue: conditionBlock
	"Evaluate the receiver once, then again as long the value of conditionBlock is true."
 
	| result |
	[result := self value.
	conditionBlock value] whileTrue.

	^ result! !

!NXTBlockFrame methodsFor: 'as yet unclassified' stamp: 'mab 8/21/2008 15:46'!
isBlock
	^ true! !

!NXTBlockFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/3/2008 19:35'!
on: exception do: handlerAction
	"Evaluate the receiver in the scope of an exception handler."
	| handlerActive |
	handlerActive := true.
	^self value! !

!NXTBlockFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/3/2008 19:35'!
restart
	<NXTPrimitive: 5>
	self restart! !

!NXTBlockFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/3/2008 19:35'!
value
	<NXTPrimitive: 2>! !

!NXTBlockFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/3/2008 19:35'!
value: aValue
	<NXTPrimitive: 2>! !

!NXTBlockFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/3/2008 19:35'!
value: aValue1 value: aValue2
	<NXTPrimitive: 2>! !

!NXTBlockFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/5/2008 11:27'!
whileFalse
	^ self whileFalse: []! !

!NXTBlockFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/3/2008 19:35'!
whileFalse: aBlock
	self value ifTrue: [ ^ nil ].
	aBlock value.
	self restart.! !

!NXTBlockFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/5/2008 11:27'!
whileTrue
	^ self whileTrue: []! !

!NXTBlockFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/3/2008 19:35'!
whileTrue: aBlock
	self value ifFalse: [ ^ nil ].
	aBlock value.
	self restart.! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/4/2008 13:35'!
argumentAt: index
	^ self isEscapedFromStack 
		ifFalse: [ Processor activeProcess stack 
			at: stackPointer - self numArgs + index ]
		ifTrue: [ self environment at: index ]! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/4/2008 16:31'!
argumentAt: index put: value
	self isEscapedFromStack
		ifFalse: [ Processor activeProcess stack 
			at: stackPointer - self numArgs + index put: value ]
		ifTrue: [ self environment at: index put: value ]! !

!NXTFrame methodsFor: 'accessing' stamp: 'mab 9/4/2008 13:26'!
environment
	^ environment! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/1/2008 16:49'!
findNextHandlerContextStarting
	"Return the next handler marked context, returning nil if there is none.  Search starts with self and proceeds up to nil."
	| ctx |
	ctx := self.
		[ctx isHandlerContext ifTrue:[^ctx].
		(ctx := ctx sender) == nil ] whileFalse.
	^nil! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/1/2008 17:24'!
handleSignal: exception
	"Sent to handler (on:do:) contexts only.  If my exception class (first arg) handles exception then execute my handle block (second arg), otherwise forward this message to the next handler context.  If none left, execute exception's defaultAction (see nil>>handleSignal:)."
	| val |
	(((self argumentAt: 1) handles: exception) and: [self tempAt: 1]) ifFalse: [
		^ self nextHandlerContext handleSignal: exception].
	"Disable myself while executing exception handler"
	self tempAt: 1 put: false.
	val := (self argumentAt: 2) value: exception.
	self tempAt: 1 put: true.
	self return: val.  "return from self if not otherwise directed in handle block"! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/1/2008 18:55'!
hasSender: aContext
	"Answer whether the receiver is strictly above context on the stack."

	| s |
	self == aContext ifTrue: [^false].
	s := self sender.
	[s == nil]
		whileFalse: 
			[s == aContext ifTrue: [^true].
			s := s sender].
	^false! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 8/21/2008 15:45'!
isBlock
	^ false! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/4/2008 13:28'!
isEscapedFromStack
	^ self environment isNil not! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/1/2008 16:51'!
isHandlerContext
	^ false! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 8/21/2008 15:45'!
isMethod
	^ false! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/1/2008 19:13'!
isUnwindContext
	^ false! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/1/2008 16:48'!
nextHandlerContext
	^ self sender findNextHandlerContextStarting! !

!NXTFrame methodsFor: 'accessing' stamp: 'mab 9/1/2008 17:42'!
numArgs
	^ numArgs! !

!NXTFrame methodsFor: 'accessing' stamp: 'mab 9/1/2008 17:42'!
numArgs: anObject
	numArgs := anObject! !

!NXTFrame methodsFor: 'accessing' stamp: 'mab 9/1/2008 17:42'!
numTemps
	^ numTemps! !

!NXTFrame methodsFor: 'accessing' stamp: 'mab 9/1/2008 17:42'!
numTemps: anObject
	numTemps := anObject! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/1/2008 18:53'!
resume: value
	thisContext terminateTo: self.
	^ value
! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/1/2008 18:43'!
return: value
	"Unwind thisContext to self and return value to self's sender.  Execute any unwind blocks while unwinding.  ASSUMES self is a sender of thisContext"

	"context ifNil: [self cannotReturn: value to: sender]."
	self sender resume: value! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/1/2008 16:48'!
sender
	^ context! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/4/2008 13:35'!
tempAt: index
	^ self isEscapedFromStack
		ifFalse: [ Processor activeProcess stack at: stackPointer + index ]
		ifTrue: [ self environment at: self numArgs + index ]! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/4/2008 16:35'!
tempAt: index put: value
	self isEscapedFromStack
		ifFalse: [ Processor activeProcess stack at: stackPointer + index put: value ]
		ifTrue: [ self environment at: self numArgs + index put: value ]! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/1/2008 18:52'!
terminate
	"Make myself unresumable."
	context := nil.
	pc := nil.
! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/1/2008 18:52'!
terminateTo: previousContext
	"Terminate all the Contexts between me and previousContext, if previousContext is on my Context stack. Make previousContext my sender."

	| currentContext sendingContext |
	(self hasSender: previousContext) ifTrue: [
		currentContext := context.
		[currentContext == previousContext] whileFalse: [
			sendingContext := currentContext sender.
			currentContext terminate.
			currentContext := sendingContext]].
	context := previousContext! !

NXTFrame subclass: #NXTMethodFrame
	instanceVariableNames: 'method selector owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTMethodFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/3/2008 19:36'!
isHandlerContext
	^ self selector = #on:do: and: [ self owner = NXTBlockFrame ]! !

!NXTMethodFrame methodsFor: 'as yet unclassified' stamp: 'mab 8/21/2008 15:46'!
isMethod
	^ true! !

!NXTMethodFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/3/2008 19:36'!
isUnwindContext
	^ self selector = #ensure: and: [ self owner = NXTBlockFrame ]! !

!NXTMethodFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/1/2008 17:33'!
owner
	^ owner! !

!NXTMethodFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/1/2008 14:26'!
selector
	^ selector! !

NXTObject subclass: #NXTImageObject
	instanceVariableNames: 'nxtClass instanceVariables'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

NXTImageObject subclass: #NXTImageCompiledMethod
	instanceVariableNames: 'literals bytecodes primitive tempCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

NXTImageCompiledMethod subclass: #NXTImageCompiledBlock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTImageCompiledBlock methodsFor: 'as yet unclassified' stamp: 'mab 9/1/2008 11:35'!
initialize
	super initialize.
	nxtClass := #NXTBlock.! !

!NXTImageCompiledMethod class methodsFor: 'as yet unclassified' stamp: 'mab 9/10/2008 16:08'!
bytecodes: bytecodes literals: literals
	^self new 
		bytecodes: bytecodes;
		literals: literals! !

!NXTImageCompiledMethod class methodsFor: 'as yet unclassified' stamp: 'mab 6/6/2008 14:57'!
elementSize
	^ 1! !

!NXTImageCompiledMethod class methodsFor: 'as yet unclassified' stamp: 'mab 4/23/2008 18:50'!
fromSelector: aSelector class: aClass within: anNXTImage 
	| aCompiledMethod |
	aCompiledMethod := aClass compiledMethodAt: aSelector.
	^ NXTMethodCompiler new
		image: anNXTImage ;
		instVarNames: aClass allInstVarNames ;
		compileMethod: aCompiledMethod! !

!NXTImageCompiledMethod class methodsFor: 'as yet unclassified' stamp: 'mab 4/16/2008 14:41'!
primitive: aNumber
	^ self new primitive: aNumber! !

!NXTImageCompiledMethod methodsFor: 'accessing' stamp: 'mab 4/15/2008 18:49'!
bytecodes
	^ bytecodes! !

!NXTImageCompiledMethod methodsFor: 'accessing' stamp: 'mab 4/15/2008 18:49'!
bytecodes: anObject
	bytecodes := anObject! !

!NXTImageCompiledMethod methodsFor: 'accessing' stamp: 'mab 4/16/2008 18:20'!
computeSize
	^ self primitive
		ifNil: [ 2 + self bytecodes size + (2 * self literals size) ]
		ifNotNil: [ 2 ]! !

!NXTImageCompiledMethod methodsFor: 'as yet unclassified' stamp: 'mab 9/1/2008 11:35'!
initialize
	super initialize.
	nxtClass := #NXTMethod.! !

!NXTImageCompiledMethod methodsFor: 'accessing' stamp: 'mab 4/15/2008 18:49'!
literals
	^ literals! !

!NXTImageCompiledMethod methodsFor: 'accessing' stamp: 'mab 4/15/2008 18:49'!
literals: anObject
	literals := anObject! !

!NXTImageCompiledMethod methodsFor: 'accessing' stamp: 'mab 4/23/2008 16:03'!
methodHeader
	^ self primitive 
		ifNil: [ (self literals size bitAnd: 16r7F) << 8 bitOr: self tempCount << 3 ]
		ifNotNil: [ 1 << 15 bitOr: (self primitive bitAnd: 16r7FFF) ]! !

!NXTImageCompiledMethod methodsFor: 'accessing' stamp: 'mab 4/16/2008 14:40'!
primitive
	^ primitive! !

!NXTImageCompiledMethod methodsFor: 'accessing' stamp: 'mab 4/16/2008 14:40'!
primitive: anObject
	primitive := anObject! !

!NXTImageCompiledMethod methodsFor: 'accessing' stamp: 'mab 4/23/2008 16:01'!
tempCount
	^ tempCount! !

!NXTImageCompiledMethod methodsFor: 'accessing' stamp: 'mab 4/23/2008 16:01'!
tempCount: anObject
	tempCount := anObject! !

!NXTImageCompiledMethod methodsFor: 'accessing' stamp: 'mab 6/6/2008 10:51'!
writeDataOn: aByteStream withImage: image
	self writeMethodHeaderOn: aByteStream.
	self primitive ifNil: [
		self literals do: [ :literal | 
			literal asNXTObject writeAsReferenceOn: aByteStream within: image ].
		self bytecodes do: [ :bytecode | aByteStream nextPut: bytecode ]].! !

!NXTImageCompiledMethod methodsFor: 'accessing' stamp: 'mab 4/23/2008 16:03'!
writeMethodHeaderOn: aByteStream
	aByteStream littleEndianWord: self methodHeader.! !

!NXTImageObject methodsFor: 'accessing' stamp: 'mab 5/21/2008 17:26'!
computeSize
	^ self instanceVariables size! !

!NXTImageObject methodsFor: 'as yet unclassified' stamp: 'mab 4/28/2008 17:34'!
initialize
	nxtClass := #NXTSystem.
	instanceVariables := OrderedCollection new.! !

!NXTImageObject methodsFor: 'accessing' stamp: 'mab 2/20/2008 03:03'!
instanceVariables
	^ instanceVariables! !

!NXTImageObject methodsFor: 'accessing' stamp: 'mab 2/20/2008 03:03'!
instanceVariables: anObject
	instanceVariables := anObject! !

!NXTImageObject methodsFor: 'accessing' stamp: 'mab 4/28/2008 16:03'!
nxtClass
	^ nxtClass ifNil: [ #NXTSystem ]! !

!NXTImageObject methodsFor: 'accessing' stamp: 'mab 2/20/2008 03:04'!
nxtClass: anObject
	nxtClass := anObject! !

NXTObject subclass: #NXTLookupKey
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

!NXTLookupKey commentStamp: 'mab 8/15/2008 15:10' prior: 0!
Methods taken from Ian Piumarta's idST (object/st80/LookupKey.st).!

NXTLookupKey subclass: #NXTAssociation
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

!NXTAssociation commentStamp: 'mab 8/15/2008 15:35' prior: 0!
Methods taken from Ian Piumarta's idST (object/st80/Association.st).!

!NXTAssociation class methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 14:00'!
key: value
	^ self key: value value: nil! !

!NXTAssociation class methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 13:48'!
key: aKey value: anObject
	^(super withKey: aKey) value: anObject; yourself! !

!NXTAssociation methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:37'!
= anAssociation
	^super = anAssociation and: [value = anAssociation value]! !

!NXTAssociation methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:37'!
hash
	^key hash bitXor: value hash! !

!NXTAssociation methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:36'!
value
	^value! !

!NXTAssociation methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:36'!
value: anObject
	value := anObject! !

!NXTLookupKey class methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:12'!
withKey: aKey
	^self new key: aKey; yourself! !

!NXTLookupKey methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:13'!
< aLookupKey
	^key < aLookupKey key! !

!NXTLookupKey methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:13'!
= anObject
	^anObject isLookupKey and: [key = anObject key]! !

!NXTLookupKey methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:14'!
hash
	^key hash! !

!NXTLookupKey methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:10'!
isLookupKey
	^ true! !

!NXTLookupKey methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:13'!
key
	^key! !

!NXTLookupKey methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:36'!
key: anObject
	key := anObject! !

NXTObject subclass: #NXTMessage
	instanceVariableNames: 'selector arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTMessage class methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 13:16'!
selector: aSymbol
	^ self selector: aSymbol arguments: NXTArray new! !

!NXTMessage class methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 13:17'!
selector: aSymbol arguments: anArray 
	"Answer an instance of me with selector, aSymbol, and arguments, 
	anArray."

	^self new selector: aSymbol arguments: anArray! !

!NXTMessage methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 11:49'!
arguments
	^ arguments! !

!NXTMessage methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 11:49'!
isMessage
	^ true! !

!NXTMessage methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 11:49'!
selector
	^ selector! !

!NXTMessage methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 11:49'!
selector: aSelector arguments: args
	selector := aSelector.
	arguments := args.! !

!NXTMessage methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 18:28'!
sendTo: aReceiver
	^ self arguments
		ifNil: [ aReceiver perform: self selector ]
		ifNotNil: [ aReceiver perform: self selector withArguments: self arguments ]! !

NXTObject subclass: #NXTMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

NXTMethod subclass: #NXTBlock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

NXTObject subclass: #NXTMotor
	instanceVariableNames: 'number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Hardware'!

!NXTMotor class methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 18:09'!
all
	^ NXTArray 
		with: (self number: 0)
		with: (self number: 1)
		with: (self number: 2)! !

!NXTMotor class methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 18:01'!
motor: aNumber mode: aMode
	<NXTPrimitive: 9>! !

!NXTMotor class methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 18:02'!
motor: aNumber speed: aSpeed
	<NXTPrimitive: 1>! !

!NXTMotor class methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 17:55'!
number: number
	^ self new
		number: number! !

!NXTMotor methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 18:04'!
mode: aNumber
	self class motor: self number mode: aNumber! !

!NXTMotor methodsFor: 'accessing' stamp: 'mab 7/22/2008 17:55'!
number
	^ number! !

!NXTMotor methodsFor: 'accessing' stamp: 'mab 7/22/2008 17:55'!
number: anObject
	number := anObject! !

!NXTMotor methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 18:05'!
speed: aNumber
	self class motor: self number speed: aNumber! !

NXTObject subclass: #NXTNumber
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

NXTNumber subclass: #NXTInteger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTInteger class methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 17:55'!
new: length neg: neg
	"Answer an instance of a large integer whose size is length. neg is a flag 
	determining whether the integer is negative or not."

	neg 
		ifTrue: [^NXTLargeNegativeInteger new: length]
		ifFalse: [^NXTLargePositiveInteger new: length]! !

!NXTInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 20:07'!
<= other
	^ self < other or: [ self = other ]! !

!NXTInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 20:07'!
> other
	^ (self <= other) not! !

!NXTInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 20:07'!
>= other
	^ (self < other) not! !

!NXTInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 17:07'!
benchFib  "Handy send-heavy benchmark"
	"(result // seconds to run) = approx calls per second"
	" | r t |
	  t _ Time millisecondsToRun: [r _ 26 benchFib].
	  (r * 1000) // t"
	"138000 on a Mac 8100/100"
	^ self < 2
		ifTrue: [1] 
		ifFalse: [(self-1) benchFib + (self-2) benchFib + 1]
! !

!NXTInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 16:50'!
benchmark  "Handy bytecode-heavy benchmark"
	"(500000 // time to run) = approx bytecodes per second"
	"5000000 // (Time millisecondsToRun: [10 benchmark]) * 1000"
	"3059000 on a Mac 8100/100"
    | size flags prime k count |
    size := 8190.
    1 to: self do:
        [:iter |
        count := 0.
		flags := nil.
        flags := (NXTArray new: size) atAllPut: true.
        1 to: size do:
            [:i | (flags at: i) ifTrue:
                [prime := i+1.
                k := i + prime.
                [k <= size] whileTrue:
                    [flags at: k put: false.
                    k := k + prime].
                count := count + 1]]].
    ^ count! !

!NXTInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 17:44'!
isInteger
	"True for all subclasses of Integer."

	^ true! !

!NXTInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 15:46'!
min: aMagnitude 
	"Answer the receiver or the argument, whichever has the lesser 
	magnitude."

	self < aMagnitude
		ifTrue: [^self]
		ifFalse: [^aMagnitude]! !

!NXTInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/11/2008 19:14'!
tinyBenchmarks
	"Report the results of running the two tiny Squeak benchmarks.
	ar 9/10/1999: Adjusted to run at least 1 sec to get more stable results"
	"0 tinyBenchmarks"
	"On a 292 MHz G3 Mac: 22727272 bytecodes/sec; 984169 sends/sec"
	"On a 400 MHz PII/Win98:  18028169 bytecodes/sec; 1081272 sends/sec"
	| t1 t2 r n1 n2 |
	n1 := 1.
	[t1 := NXTTime millisecondsToRun: [n1 benchmark].
	t1 < 1000] whileTrue:[n1 := n1 * 2]. "Note: #benchmark's runtime is about O(n)"
	
	n2 := 28.
	[t2 := NXTTime millisecondsToRun: [r := n2 benchFib].
	t2 < 1000] whileTrue:[n2 := n2 + 1]. 
	"Note: #benchFib's runtime is about O(k^n),
		where k is the golden number = (1 + 5 sqrt) / 2 = 1.618...."
		
	"((n1 * 500000 * 1000) // t1) print.
	' bytecodes/sec; ' print,
	  ((r * 1000) // t2) print.
	' sends/sec' printNl."! !

!NXTInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 19:15'!
to: stop by: step do: aBlock 
	"Normally compiled in-line, and therefore not overridable.
	Evaluate aBlock for each element of the interval (self to: stop by: 
step)."
	| nextValue |
	nextValue := self.
	step = 0 ifTrue: [self error: 'step must be non-zero'].
	step < 0
		ifTrue: [[stop <= nextValue]
				whileTrue: 
					[aBlock value: nextValue.
					nextValue := nextValue + step]]
		ifFalse: [[stop >= nextValue]
				whileTrue: 
					[aBlock value: nextValue.
					nextValue := nextValue + step]]! !

NXTInteger variableByteSubclass: #NXTLargePositiveInteger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

NXTLargePositiveInteger variableByteSubclass: #NXTLargeNegativeInteger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTLargePositiveInteger class methodsFor: 'nxt-exclude' stamp: 'mab 9/8/2008 12:20'!
elementSize
	^ 1! !

!NXTLargePositiveInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 19:42'!
* other
	<NXTPrimitive: 43>! !

!NXTLargePositiveInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 19:56'!
+ other
	<NXTPrimitive: 14>! !

!NXTLargePositiveInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 19:55'!
- other
	<NXTPrimitive: 40>! !

!NXTLargePositiveInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 20:05'!
// other
	| temp n |
	temp := self.
	n := 0.
	[ temp > 0] whileTrue: [ temp := temp - other. n := n + 1 ].
	^ n! !

!NXTLargePositiveInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 16:41'!
< other
	<NXTPrimitive: 41>! !

!NXTLargePositiveInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 20:13'!
= other
	<NXTPrimitive: 44>
	^ super = other! !

!NXTLargePositiveInteger methodsFor: 'nxt-exclude' stamp: 'mab 9/8/2008 13:56'!
computeSize
	^ self size! !

!NXTLargePositiveInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 18:06'!
digitAt: index
	^ self at: index! !

!NXTLargePositiveInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 18:06'!
digitAt: index put: object
	^ self at: index put: object! !

!NXTLargePositiveInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 17:53'!
digitLength
	^ super size! !

!NXTLargePositiveInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 14:12'!
print
	<NXTPrimitive: 13>! !

!NXTLargePositiveInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 14:12'!
printNl
	self print.
	String cr print.! !

!NXTLargePositiveInteger methodsFor: 'nxt-exclude' stamp: 'mab 9/8/2008 13:56'!
writeDataOn: aByteStream withImage: image
	1 to: self size do: [ :index |
		aByteStream nextPut: (self at: index) asInteger ].! !

NXTInteger subclass: #NXTSmallInteger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTSmallInteger class methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 11:44'!
maxVal
	^ 16r3FFF! !

!NXTSmallInteger class methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 11:44'!
minVal
	^ -16r4000! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 6/6/2008 15:40'!
* other
	<NXTPrimitive: 22>! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 4/29/2008 15:25'!
+ other
	<NXTPrimitive: 3>! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 6/2/2008 15:24'!
- aNumber
	<NXTPrimitive: 19>! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 6/2/2008 15:20'!
// aNumber
	<NXTPrimitive: 18>! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 5/16/2008 21:46'!
< other
	<NXTPrimitive: 11>! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/1/2008 17:50'!
<< shift
	^ self bitShift: shift! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/1/2008 17:50'!
>> shift
	^ self bitShift: shift negated! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 18:31'!
\\ aNumber
	<NXTPrimitive: 37>! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 14:42'!
asInteger
	^ self! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 5/7/2008 17:38'!
bitAnd: other
	<NXTPrimitive: 8>! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 19:14'!
bitOr: other
	<NXTPrimitive: 42>! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 14:43'!
bitShift: shift
	<NXTPrimitive: 31>! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/11/2008 15:54'!
bitXor: other
	<NXTPrimitive: 23>! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 7/29/2008 13:11'!
digitAt: n 
	"Answer the value of an indexable field in the receiver.  LargePositiveInteger uses bytes of base two number, and each is a 'digit' base 256.  Fail if the argument (the index) is not an Integer or is out of bounds."
	n>4 ifTrue: [^ 0].
	self < 0
		ifTrue: 
			[self = NXTSmallInteger minVal ifTrue:
				["Can't negate minVal -- treat specially"
				^ #(0 0 0 64) at: n].
			^ ((0-self) bitShift: (1-n)*8) bitAnd: 16rFF]
		ifFalse: [^ (self bitShift: (1-n)*8) bitAnd: 16rFF]! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 17:52'!
digitLength
	"Answer the number of indexable fields in the receiver. This value is the 
	same as the largest legal subscript. Included so that a SmallInteger can 
	behave like a LargePositiveInteger or LargeNegativeInteger."

	(self < 16r100 and: [self > -16r100]) ifTrue: [^ 1].
	^ 2
! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 5/7/2008 17:55'!
isZero
	^ self = 0! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 6/2/2008 15:26'!
max: aNumber
	self < aNumber
		ifTrue: [ ^ aNumber ]
		ifFalse: [ ^ self ]! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 7/21/2008 16:01'!
print
	<NXTPrimitive: 4>
	Transcript show: self asString! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 7/21/2008 16:02'!
printNl
	self print.
	NXTString cr print.! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 6/3/2008 14:08'!
to: stop do: aBlock 
	| nextValue |
	nextValue := self.
	[ nextValue <= stop ]
		whileTrue: 
			[ aBlock value: nextValue.
			nextValue := nextValue + 1 ]! !

!NXTNumber methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 17:42'!
negated
	"Answer a Number that is the negation of the receiver."

	^0 - self! !

!NXTNumber methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 17:42'!
negative
	"Answer whether the receiver is mathematically negative."

	^ self < 0! !

!NXTObject class methodsFor: 'nxt-exclude' stamp: 'mab 6/5/2008 17:11'!
elementSize
	^ 2! !

!NXTObject class methodsFor: 'nxt-exclude' stamp: 'mab 8/12/2008 14:39'!
includes
	"A set of classes to be dynamically included by this class"
	^ OrderedCollection new! !

!NXTObject methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 13:48'!
->	anObject
	^NXTAssociation key: self value: anObject! !

!NXTObject methodsFor: 'comparing' stamp: 'mab 6/6/2008 16:27'!
= other
	^ self == other! !

!NXTObject methodsFor: 'comparing' stamp: 'mab 6/6/2008 16:27'!
== other
	<NXTPrimitive: 7>
	^ self == other! !

!NXTObject methodsFor: 'as yet unclassified' stamp: 'mab 6/6/2008 10:38'!
asNXTObject
	^ self! !

!NXTObject methodsFor: 'as yet unclassified' stamp: 'mab 6/2/2008 15:33'!
at: anInteger
	<NXTPrimitive: 20>
	^ super at: anInteger! !

!NXTObject methodsFor: 'as yet unclassified' stamp: 'mab 6/2/2008 15:34'!
at: anInteger put: anObject
	<NXTPrimitive: 21>
	^ super at: anInteger put: anObject! !

!NXTObject methodsFor: 'as yet unclassified' stamp: 'mab 5/21/2008 17:36'!
class
	<NXTPrimitive: 12>! !

!NXTObject methodsFor: 'nxt-exclude' stamp: 'mab 5/21/2008 10:26'!
computeSize
	^ self class allInstVarNames size! !

!NXTObject methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 13:41'!
error: aString
	NXTError signal: aString.
	! !

!NXTObject methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 16:59'!
halt
	<NXTPrimitive: 34>
	super halt.! !

!NXTObject methodsFor: 'comparing' stamp: 'mab 8/15/2008 17:21'!
hash
	<NXTPrimitive: 36>
	^ super hash! !

!NXTObject methodsFor: 'nxt-exclude' stamp: 'mab 9/8/2008 15:36'!
header
	| header |
	self computeSize >= 16r1FFF ifTrue: [ self halt ].
	header := (self class elementSize bitAnd: 3) << 13 bitOr: self computeSize.
	^ header! !

!NXTObject methodsFor: 'testing' stamp: 'mab 7/22/2008 18:16'!
ifNil: aBlock! !

!NXTObject methodsFor: 'testing' stamp: 'mab 8/19/2008 13:27'!
ifNil: nilBlock ifNotNil: ifNotNilBlock
	"Evaluate the block, unless I'm == nil (q.v.)"

	^ ifNotNilBlock value! !

!NXTObject methodsFor: 'testing' stamp: 'mab 8/19/2008 13:26'!
ifNotNil: ifNotNilBlock ifNil: nilBlock 
	"If I got here, I am not nil, so evaluate the block ifNotNilBlock"

	^ ifNotNilBlock value! !

!NXTObject methodsFor: 'as yet unclassified' stamp: 'mab 5/29/2008 15:56'!
initialize! !

!NXTObject methodsFor: 'nxt-exclude' stamp: 'mab 5/21/2008 17:19'!
instanceVariables
	| c |
	c := OrderedCollection new.
	self class allInstVarNames doWithIndex: [ :name :index |
		c add: (self instVarAt: index) ].
	^ c! !

!NXTObject methodsFor: 'as yet unclassified' stamp: 'mab 5/22/2008 16:35'!
isClass
	^ false! !

!NXTObject methodsFor: 'testing' stamp: 'mab 8/19/2008 15:06'!
isDictionary
	^ false! !

!NXTObject methodsFor: 'testing' stamp: 'mab 8/19/2008 14:22'!
isKindOf: aClass 
	"Answer whether the class, aClass, is a superclass or class of the receiver."

	self class == aClass
		ifTrue: [^true]
		ifFalse: [^self class inheritsFrom: aClass]! !

!NXTObject methodsFor: 'testing' stamp: 'mab 8/15/2008 15:10'!
isLookupKey
	^ false! !

!NXTObject methodsFor: 'testing' stamp: 'mab 8/15/2008 11:44'!
isMessage
	^ false! !

!NXTObject methodsFor: 'as yet unclassified' stamp: 'mab 5/21/2008 16:33'!
isMeta
	^ false! !

!NXTObject methodsFor: 'testing' stamp: 'mab 8/15/2008 16:21'!
isNXTObject
	^ true! !

!NXTObject methodsFor: 'as yet unclassified' stamp: 'mab 5/20/2008 14:22'!
isNil
	^ false! !

!NXTObject methodsFor: 'testing' stamp: 'mab 8/19/2008 15:57'!
isString
	^ false! !

!NXTObject methodsFor: 'testing' stamp: 'mab 7/25/2008 19:15'!
isSymbol
	^ false! !

!NXTObject methodsFor: 'as yet unclassified' stamp: 'mab 7/14/2008 16:11'!
nextInstance
	<NXTPrimitive: 29>! !

!NXTObject methodsFor: 'nxt-exclude' stamp: 'mab 5/21/2008 10:29'!
nxtClass
	^ self class name asSymbol! !

!NXTObject methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 10:50'!
perform: aSymbol
	<NXTPrimitive: 25>
	^ super perform: aSymbol! !

!NXTObject methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 15:00'!
perform: aSymbol with: anObject
	<NXTPrimitive: 25>
	^ super perform: aSymbol with: anObject! !

!NXTObject methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 18:43'!
perform: aSymbol withArguments: anArray
	<NXTPrimitive: 38>
	^ super perform: aSymbol withArguments: anArray! !

!NXTObject methodsFor: 'as yet unclassified' stamp: 'mab 6/3/2008 15:45'!
printString: aString
	<NXTPrimitive: 0>
	Transcript show: aString; cr.! !

!NXTObject methodsFor: 'as yet unclassified' stamp: 'mab 6/2/2008 15:28'!
size
	<NXTPrimitive: 17>
	^ super size! !

!NXTObject methodsFor: 'as yet unclassified' stamp: 'mab 5/29/2008 14:41'!
species
	^ self class! !

!NXTObject methodsFor: 'as yet unclassified' stamp: 'mab 5/20/2008 14:23'!
value
	^ self! !

!NXTObject methodsFor: 'nxt-exclude' stamp: 'mab 7/21/2008 16:38'!
writeAsReferenceOn: aByteStream within: image
	aByteStream littleEndianWord: (((image mapper idFor: self) bitShift: 1) bitOr: 1)! !

!NXTObject methodsFor: 'nxt-exclude' stamp: 'mab 7/21/2008 17:20'!
writeClassOn: aByteStream withImage: image
	| class |
	class := image classMapping at: self ifAbsent: [ self nxtClass isSymbol 
		ifTrue: [ image classAt: self nxtClass ]
		ifFalse: [ self nxtClass ]].
	class writeAsReferenceOn: aByteStream within: image.! !

!NXTObject methodsFor: 'nxt-exclude' stamp: 'mab 7/24/2008 16:57'!
writeDataOn: aByteStream withImage: image
	self instanceVariables do: [ :instanceVariable |
		instanceVariable ifNil: [ instanceVariable := image specialObjectAt: #nil ].
		instanceVariable asNXTObject writeAsReferenceOn: aByteStream within: image ].! !

!NXTObject methodsFor: 'nxt-exclude' stamp: 'mab 5/21/2008 10:35'!
writeHeaderOn: aByteStream
	aByteStream littleEndianWord: self header.! !

!NXTObject methodsFor: 'nxt-exclude' stamp: 'mab 5/21/2008 14:55'!
writeOn: aByteStream withImage: image
	self writeHeaderOn: aByteStream.
	self writeClassOn: aByteStream withImage: image.
	self writeDataOn: aByteStream withImage: image.! !

!NXTObject methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 13:29'!
yourself! !

!NXTObject methodsFor: 'comparing' stamp: 'mab 7/25/2008 19:09'!
~= anObject 
	"Answer whether the receiver and the argument do not represent the 
	same object."

	^self = anObject == false! !

!NXTObject methodsFor: 'comparing' stamp: 'mab 9/8/2008 18:18'!
~~ anObject
	"Answer whether the receiver and the argument are not the same object 
	(do not have the same object pointer)."

	self == anObject
		ifTrue: [^ false]
		ifFalse: [^ true]! !

NXTObject subclass: #NXTProcess
	instanceVariableNames: 'currentFrame stack stackTopIndex poolSize framePool'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTProcess methodsFor: 'as yet unclassified' stamp: 'mab 9/3/2008 18:11'!
stack
	^ stack! !

NXTObject subclass: #NXTProcessorScheduler
	instanceVariableNames: 'activeProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTProcessorScheduler methodsFor: 'as yet unclassified' stamp: 'mab 9/3/2008 16:08'!
activeProcess
	^ activeProcess! !

NXTObject subclass: #NXTProgram
	instanceVariableNames: 'display motors buttons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Programs'!

NXTProgram subclass: #NXTBenchmark
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Programs'!

!NXTBenchmark methodsFor: 'as yet unclassified' stamp: 'mab 9/10/2008 17:16'!
run
	'Running tiny benchmarks...' printNl.
	0 tinyBenchmarks.! !

NXTProgram subclass: #NXTDrivingExample
	instanceVariableNames: 'running enterPressed driving right left'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Programs'!

!NXTDrivingExample methodsFor: 'button reading' stamp: 'mab 7/22/2008 18:48'!
checkEnterDown: key
	(self buttonEnter isPressed) & enterPressed not ifTrue: [
		enterPressed := true ].! !

!NXTDrivingExample methodsFor: 'button reading' stamp: 'mab 7/22/2008 18:49'!
checkEnterUp: key
	(self buttonEnter isPressed) not & enterPressed ifTrue: [
		enterPressed := false.
		driving 
			ifFalse: [ 'Start driving' printNl.
				self driveAhead.
				driving := true ]
			ifTrue: [  'Stop driving' printNl.
				self stopDriving.
				driving := false ]].! !

!NXTDrivingExample methodsFor: 'button reading' stamp: 'mab 7/22/2008 18:49'!
checkLeft: key
	(self buttonLeft isPressed) & left not ifTrue: [
		left := true.
		self driveLeft ].
	(self buttonLeft isPressed) not & left ifTrue: [
		left := false.
		self driveAhead ].! !

!NXTDrivingExample methodsFor: 'button reading' stamp: 'mab 7/22/2008 18:50'!
checkRight: key
	(self buttonRight isPressed) & right not & left not ifTrue: [
		right := true.
		self driveRight ].
	(self buttonRight isPressed) not & right ifTrue: [
		right := false.
		self driveAhead ].! !

!NXTDrivingExample methodsFor: 'driving' stamp: 'mab 7/22/2008 18:14'!
driveAhead
	self motorA 
		mode: 1;
		speed: 75.
	self motorB
		mode: 1;
		speed: 75.! !

!NXTDrivingExample methodsFor: 'driving' stamp: 'mab 7/22/2008 18:20'!
driveBack
	self motorA
		mode: 1;
		speed: -75.
	self motorB
		mode: 1;
		speed: -75.! !

!NXTDrivingExample methodsFor: 'driving' stamp: 'mab 7/22/2008 18:21'!
driveLeft
	self motorA
		mode: 0;
		speed: 0.
	self motorB
		mode: 1;
		speed: 75.! !

!NXTDrivingExample methodsFor: 'driving' stamp: 'mab 7/22/2008 18:23'!
driveRight
	self motorA
		mode: 1;
		speed: 75.
	self motorB
		mode: 0;
		speed: 0.! !

!NXTDrivingExample methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 17:15'!
initialize
	self stopDriving.
	running := true.
	enterPressed := false.
	driving := false.
	left := false.
	right := false.! !

!NXTDrivingExample methodsFor: 'running' stamp: 'mab 7/22/2008 17:24'!
keyLoop
	| key |
	key := NXTButton buttonRead.
	key = NXTButton exitButton ifTrue: [ running := false ].
	self checkEnterDown: key.
	self checkEnterUp: key.
	self checkLeft: key.
	self checkRight: key.! !

!NXTDrivingExample methodsFor: 'running' stamp: 'mab 7/22/2008 17:45'!
run
	'Entering driving mode now: ' printNl.
	'Enter to start and stop engine' printNl.
	'Left/Right for steering' printNl.
	[ running ] whileTrue: [ self keyLoop ].
	'Goodbye!!' printNl.! !

!NXTDrivingExample methodsFor: 'driving' stamp: 'mab 7/22/2008 18:23'!
stopDriving
	self motorA
		mode: 0;
		speed: 0.
	self motorB
		mode: 0;
		speed: 0.! !

!NXTProgram methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 18:47'!
buttonEnter
	^ self buttons at: NXTButton enterButton! !

!NXTProgram methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 18:47'!
buttonExit
	^ self buttons at: NXTButton exitButton! !

!NXTProgram methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 18:47'!
buttonLeft
	^ self buttons at: NXTButton leftButton! !

!NXTProgram methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 18:47'!
buttonRight
	^ self buttons at: NXTButton rightButton! !

!NXTProgram methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 14:36'!
buttons
	^ buttons ifNil: [ buttons := NXTButtonContainer new ]! !

!NXTProgram methodsFor: 'as yet unclassified' stamp: 'mab 7/23/2008 16:15'!
display
	^ display ifNil: [ display := NXTDisplay new ]! !

!NXTProgram methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 18:11'!
motorA
	^ self motors at: 1! !

!NXTProgram methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 18:11'!
motorB
	^ self motors at: 2! !

!NXTProgram methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 18:11'!
motorC
	^ self motors at: 3! !

!NXTProgram methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 18:10'!
motors
	^ motors ifNil: [ motors := NXTMotor all ]! !

!NXTProgram methodsFor: 'running' stamp: 'mab 7/22/2008 17:09'!
run
	self subclassResponsibility! !

NXTProgram subclass: #NXTSimpleProgram
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Programs'!

!NXTSimpleProgram methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 17:20'!
run
	'It worked!!' printNl.! !

NXTProgram subclass: #NXTSystem
	instanceVariableNames: 'programs selected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Programs'!

!NXTSystem methodsFor: 'system' stamp: 'mab 8/12/2008 17:56'!
allClasses
	^ NXTObject allSubclasses! !

!NXTSystem methodsFor: 'system' stamp: 'mab 8/13/2008 15:39'!
doKeyAction
	| key |
	key := self buttons waitForAny.
	key = self buttons exit ifTrue: [
		^ #exit ].
	key = self buttons left ifTrue: [ self menuUp ].
	key = self buttons right ifTrue: [ self menuDown ].
	key = self buttons enter ifTrue: [ self execute ].! !

!NXTSystem methodsFor: 'system' stamp: 'mab 9/10/2008 17:18'!
execute
	| program |
	program := self programs at: self selected.
	self display clear.
	[ program new run ] on: NXTError do: [ :error |
		('Got an error: ', error messageText) printNl ].
	('Finished ', program name, '. Press any key') printNl.
	self buttons waitForAny. 
	self reloadPrograms.! !

!NXTSystem methodsFor: 'system' stamp: 'mab 8/13/2008 15:29'!
menuDown
	self selected: self selected + 1.
	self selected > self programs size ifTrue: [
		self selected: 1 ].! !

!NXTSystem methodsFor: 'system' stamp: 'mab 8/13/2008 15:27'!
menuUp
	self selected: self selected - 1.
	self selected isZero ifTrue: [
		self selected: self programs size ].! !

!NXTSystem methodsFor: 'accessing' stamp: 'mab 8/13/2008 13:52'!
programs
	^ programs! !

!NXTSystem methodsFor: 'accessing' stamp: 'mab 8/13/2008 13:52'!
programs: anObject
	programs := anObject! !

!NXTSystem methodsFor: 'system' stamp: 'mab 8/15/2008 09:57'!
reloadPrograms
	self programs: (NXTProgram subclasses asOrderedCollection 
		reject: [ :program2 | program2 = NXTSystem ]).
	'bubu' printNl.
	self selected: 1.! !

!NXTSystem methodsFor: 'system' stamp: 'mab 9/10/2008 17:13'!
run
	Smalltalk rehash.
	[ self halt. self error: 'blub'] on: Error do: [ :error | 'huhu' printNl ].
	self reloadPrograms.
	[ self showMenu ] doWhileTrue: [ self doKeyAction ~= #exit ].
	('Finished ') printNl.
	'Press any key' printNl.
	NXTButton waitForAnyKey.
	NXTDrivingExample.
	NXTUsbManager.
	NXTTestRunner.
	NXTBenchmark.! !

!NXTSystem methodsFor: 'accessing' stamp: 'mab 8/13/2008 13:52'!
selected
	^ selected! !

!NXTSystem methodsFor: 'accessing' stamp: 'mab 8/13/2008 13:52'!
selected: anObject
	selected := anObject! !

!NXTSystem methodsFor: 'system' stamp: 'mab 9/10/2008 17:17'!
showMenu
	| index |
	self display clear.
	index := 0.
	self programs do: [ :prog |
		index := index + 1.
		self selected = index 
			ifTrue: [ '> ' print ]
			ifFalse: [ '  ' print ].
		prog name asString printNl.
	].! !

NXTProgram subclass: #NXTTestRunner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Programs'!

!NXTTestRunner class methodsFor: 'nxt-exclude' stamp: 'mab 8/12/2008 14:42'!
includes
	^ NXTTestCase allSubclasses! !

!NXTTestRunner methodsFor: 'as yet unclassified' stamp: 'mab 8/12/2008 14:29'!
run
	NXTTestCase allSubclassesDo: [ :testCase |
		testCase new run ].! !

NXTProgram subclass: #NXTUsbManager
	instanceVariableNames: 'connection running'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Programs'!

!NXTUsbManager class methodsFor: 'as yet unclassified' stamp: 'mab 8/18/2008 17:59'!
includes
	^ { NXTMessage }! !

!NXTUsbManager methodsFor: 'accessing' stamp: 'mab 7/25/2008 18:43'!
connection
	^ connection! !

!NXTUsbManager methodsFor: 'accessing' stamp: 'mab 7/25/2008 18:43'!
connection: anObject
	connection := anObject! !

!NXTUsbManager methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 19:14'!
exit
	running := false.! !

!NXTUsbManager methodsFor: 'as yet unclassified' stamp: 'mab 8/18/2008 11:59'!
getClassList
	| classes |
	classes := Smalltalk keys.
	self connection nextPut: classes asArray.
	self connection flush.! !

!NXTUsbManager methodsFor: 'as yet unclassified' stamp: 'mab 8/20/2008 11:31'!
run
	| next |
	'Waiting for USB connection...' printNl.
	[ NXTUsb isConnected not ] whileTrue: [ 10 ].
	'Got one - waiting for messages' printNl.
	self connection: (NXTDataStream on: NXTUsbStream new).
	running := true.
	[ running ] whileTrue: [
		next := self connection next.
		next isMessage ifFalse: [ self error: 'USB connection out of sync' ].
		('Got ', next selector, ' message') printNl.
		next sendTo: self.
	].! !

!NXTUsbManager methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 18:00'!
storeClass: aClass metaclass: aMetaclass
	| newClass |
	(Smalltalk at: aClass name) become: aClass.
	newClass := Smalltalk at: aClass name.
	newClass class: aMetaclass.
	aMetaclass class: NXTMetaclass.! !

!NXTUsbManager methodsFor: 'as yet unclassified' stamp: 'mab 8/20/2008 11:28'!
test: n1 write: n2
	n1 printNl.
	n2 printNl.! !

NXTObject subclass: #NXTStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Streams'!

NXTStream subclass: #NXTDataStream
	instanceVariableNames: 'byteStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Streams'!

!NXTDataStream class methodsFor: 'as yet unclassified' stamp: 'mab 7/14/2008 18:45'!
on: aStream
	^ self new setStream: aStream! !

!NXTDataStream class methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 15:12'!
typeIDs
	^ #(#NXTSymbol #NXTString #NXTSmallInteger #NXTArray)! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 13:59'!
beginInstance: aClass size: size
	self writeSmallInteger: size.
	self nextPut: aClass name.! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 14:31'!
classNameFor: anObject
	| name |
	name := anObject class name.
	(name beginsWith: 'NXT') ifFalse: [ name := 'NXT', name ].
	^ name asSymbol! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 15:58'!
close
	^ byteStream close! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 7/30/2008 11:07'!
flush
	^ byteStream flush! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 13:23'!
methodNameFor: anObject
	^ ('write', ((self classNameFor: anObject) allButFirst: 3)) asSymbol asMutator! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 17:07'!
next
	| type |
	type := byteStream next.
	type isZero ifTrue: [ ^ self readInstance ].
	^ self perform: ('read', ((self class typeIDs at: type) allButFirst: 3)) asSymbol.
! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:00'!
nextPut: anObject
	| nxtObject typeID |
	nxtObject := anObject asNXTObject.
	typeID := self typeIDFor: nxtObject.
	byteStream nextPut: typeID.
	typeID isZero 
		ifTrue: [ self writeInstance: nxtObject ]
		ifFalse: [ self perform: (self methodNameFor: nxtObject) with: nxtObject ].
	! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 15:46'!
readArray
	| size |
	size := byteStream int16.
	^ self next: size! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 17:08'!
readInstance
	| instSize className newClass anObject |
	instSize := self readSmallInteger.
	className := self next.
	newClass := Smalltalk at: className.
	anObject := newClass basicNew.
	1 to: instSize do: [ :i |
		anObject at: i put: self next ].
	^ anObject! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 7/21/2008 16:11'!
readSmallInteger
	^ byteStream int16! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 7/14/2008 20:09'!
readString
	^ byteStream nextString! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 10:50'!
readSymbol
    ^ self readString asSymbol! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 7/14/2008 20:02'!
reset
	byteStream reset! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 7/14/2008 18:45'!
setStream: aStream
	aStream binary.
	byteStream := aStream.! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 8/12/2008 14:04'!
typeIDFor: anObject
	^ self class typeIDs indexOf: (self classNameFor: anObject)! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 7/29/2008 18:13'!
writeArray: array
	byteStream int16: array size.
	self nextPutAll: array.! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 13:37'!
writeInstance: anObject
	| instVarCount |
	instVarCount := anObject class instSize.
	self beginInstance: anObject class size: instVarCount.
	1 to: instVarCount do: [ :i |
		self nextPut: (anObject instVarAt: i) ].
	! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 7/21/2008 16:11'!
writeSmallInteger: int
	byteStream int16: int.! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 7/14/2008 19:32'!
writeString: aString
	byteStream nextStringPut: aString! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 7/21/2008 14:45'!
writeSymbol: aSymbol
	self writeString: aSymbol! !

!NXTStream methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 14:41'!
ascii
	"NXT streams are always binary for now"! !

!NXTStream methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 14:41'!
binary
	"NXT streams are always binary for now"! !

!NXTStream methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 15:57'!
close! !

!NXTStream methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 15:47'!
next: count
	| array |
	array := NXTArray new: count.
	1 to: count do: [ :i |
		array at: i put: self next ].
	^ array! !

!NXTStream methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 15:58'!
nextPutAll: aCollection
	aCollection do: [ :each |
		self nextPut: each ].! !

NXTStream subclass: #NXTUsbStream
	instanceVariableNames: 'inputBuffer inputBufferPos outputBuffer outputBufferPos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Streams'!

!NXTUsbStream methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 14:13'!
flush
	NXTUsb send: (outputBuffer copyFrom: 1 to: outputBufferPos - 1).
	self reset.! !

!NXTUsbStream methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 14:40'!
initialize
	outputBuffer := NXTString new: 64.
	outputBufferPos := 1.! !

!NXTUsbStream methodsFor: 'as yet unclassified' stamp: 'mab 7/21/2008 16:57'!
int16
	"Answer the next signed, 16-bit integer from this (binary) stream."

	| n |
	n := self next.
	n := (n bitShift: 8) + (self next).
	"n >= 16r8000 ifTrue: [n := n - 16r10000]."
	^ n! !

!NXTUsbStream methodsFor: 'as yet unclassified' stamp: 'mab 7/29/2008 11:52'!
int16: anInteger
	"Store the given signed, 16-bit integer on this (binary) stream."

	| n |
	"(anInteger < -16r8000) | (anInteger >= 16r8000)
		ifTrue: [self error: 'outside 16-bit integer range'].

	anInteger < 0
		ifTrue: [n := 16r10000 + anInteger]
		ifFalse: [n := anInteger]."
	n := anInteger.
	self nextPut: (n digitAt: 2).
	self nextPut: (n digitAt: 1).
! !

!NXTUsbStream methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 14:18'!
next
	| value |
	(inputBuffer isNil or: [ inputBufferPos > inputBuffer size ]) ifTrue: [
		inputBuffer := NXTUsb read.
		inputBufferPos := 1 ].
	value := inputBuffer at: inputBufferPos.
	inputBufferPos := inputBufferPos + 1.
	^ value! !

!NXTUsbStream methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 14:12'!
nextPut: anInteger
	outputBuffer at: outputBufferPos put: anInteger.
	(outputBufferPos := outputBufferPos + 1) > NXTUsb packetSize ifTrue: [
		self flush ].! !

!NXTUsbStream methodsFor: 'as yet unclassified' stamp: 'mab 7/16/2008 17:29'!
nextString
	"Read a string from the receiver. The first byte is the length of the string, unless it is greater than 192, in which case the first four bytes encode the length.  I expect to be in ascii mode when called (caller puts back to binary)."

	| length aByteArray |

	"read the length in binary mode"
	self binary.
	length := self next.		"first byte."
	length >= 192 ifTrue: [length := length - 192.
		1 to: 3 do: [:ii | length := length * 256 + self next]].
	aByteArray := NXTString new: length.

	1 to: length do: [ :i | aByteArray at: i put: self next ].
	^aByteArray asString.
! !

!NXTUsbStream methodsFor: 'as yet unclassified' stamp: 'mab 7/29/2008 18:14'!
nextStringPut: s 
	"Append the string, s, to the receiver.  Only used by DataStream.  Max size of 64*256*256*256."

	| length |
	(length := s size) < 192
		ifTrue: [self nextPut: length]
		ifFalse: 
			[self nextPut: (length digitAt: 4)+192.
			self nextPut: (length digitAt: 3).
			self nextPut: (length digitAt: 2).
			self nextPut: (length digitAt: 1)].
	self nextPutAll: s.
	^s! !

!NXTUsbStream methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 14:12'!
reset
	outputBufferPos := 1.! !

NXTObject subclass: #NXTTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

NXTTestCase subclass: #NXTArrayTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Tests'!

!NXTArrayTest methodsFor: 'as yet unclassified' stamp: 'mab 6/3/2008 14:40'!
testSize
	self assert: (NXTArray new: 5) size = 5
	! !

NXTTestCase subclass: #NXTBlockTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Tests'!

!NXTBlockTest methodsFor: 'as yet unclassified' stamp: 'mab 9/4/2008 15:23'!
closure
	| temp |
	temp := #kickass.
	^ [ temp = #kickass ]! !

!NXTBlockTest methodsFor: 'as yet unclassified' stamp: 'mab 9/10/2008 17:14'!
testBlockStacks
	"This should work without crashes"
	[ self error: 'mist' ] on: Error do: [].
	[ :block | block ] value: [ ].
	[ ] value.
	true or: [ ].
	[ ]  isBlock.
	10 print.! !

!NXTBlockTest methodsFor: 'as yet unclassified' stamp: 'mab 9/4/2008 11:51'!
testClosure
	| block |
	block := self closure.
	self assert: block value! !

!NXTBlockTest methodsFor: 'as yet unclassified' stamp: 'mab 6/3/2008 13:33'!
testTemporaryAssignmentFromBlock
	| temp |
	temp := 10.
	[ temp := 5 ] value.
	self assert: temp = 5.! !

NXTTestCase subclass: #NXTDictionaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Tests'!

!NXTDictionaryTest methodsFor: 'tests' stamp: 'mab 8/18/2008 18:32'!
testAdd
	
	| dict |
	dict := NXTDictionary new.
	dict add: #a -> 1.
	dict add: #b -> 2.
	self assert: (dict at: #a) = 1.
	self assert: (dict at: #b) = 2! !

!NXTDictionaryTest methodsFor: 'tests' stamp: 'mab 8/18/2008 18:32'!
testAddAll
	
	| dict1 dict2 |
	dict1 := NXTDictionary new.
	dict1 at: #a put:1 ; at: #b put: 2. 
	dict2 := Dictionary new.
	dict2 at: #a put: 3 ; at: #c put: 4.
	dict1 addAll: dict2.
	self assert: (dict1 at: #a) = 3.
	self assert: (dict1 at: #b) = 2.
	self assert: (dict1 at: #c) = 4.! !

!NXTDictionaryTest methodsFor: 'association tests' stamp: 'mab 8/18/2008 18:32'!
testAddAssociation
	"self run:#testAddAssociation"
	"self debug:#testAddAssociation"
	
	| dict |
	dict := NXTDictionary new.
	dict at: #a put: 1.
	dict at: #b put: 2.
	self assert: (dict at: #a) = 1.
	self assert: (dict at: #b) = 2.
	
	dict at: #a put: 10.
	dict at: #c put: 2.
	
	self assert: (dict at: #a) = 10.
	self assert: (dict at: #b) = 2.
	self assert: (dict at: #c) = 2
	
	! !

!NXTDictionaryTest methodsFor: 'association tests' stamp: 'mab 8/19/2008 14:24'!
testAssociationsSelect
	| answer d |
	d := NXTDictionary new.
	d at: (NXTArray with: #hello with: #world)
	  put: #fooBar.
	d at: Smalltalk put: #'Smalltalk is the key'.
	d at: #Smalltalk put: Smalltalk.
	answer := d
				associationsSelect: [:assoc | assoc key == #Smalltalk
						and: [assoc value == Smalltalk]].
	self
		should: [answer isKindOf: NXTDictionary].
	self
		should: [answer size == 1].
	self
		should: [(answer at: #Smalltalk)
				== Smalltalk].
	answer := d
				associationsSelect: [:assoc | assoc key == #NoSuchKey
						and: [assoc value == #NoSuchValue]].
	self
		should: [answer isKindOf: NXTDictionary].
	self
		should: [answer size == 0]! !

!NXTDictionaryTest methodsFor: 'basic tests' stamp: 'mab 8/18/2008 18:34'!
testAtError
	"self run: #testAtError"
	
	| dict |
	dict := NXTDictionary new.
	dict at: #a put: 666.
	self shouldnt: [ dict at: #a ] raise: NXTError.
	self should: [ dict at: #b ] raise: NXTError.
	
	! !

!NXTDictionaryTest methodsFor: 'basic tests' stamp: 'mab 8/18/2008 18:34'!
testAtIfAbsent
	"self run: #testAtIfAbsent"
	
	| dict |
	dict := NXTDictionary new.
	dict at: #a put: 666.
	
	self assert: (dict at: #a ifAbsent: [nil]) = 666.
	
	self assert: (dict at: #b ifAbsent: [nil]) isNil.

	! !

!NXTDictionaryTest methodsFor: 'implementation tests' stamp: 'mab 8/18/2008 18:34'!
testAtNil
	"(self run: #testAtNil)"
	"nil is a valid key in squeak. In VW nil is not a valid key"
	"Ansi 1.9 p, 168
    		5.7.2.5 Message: at: key put: newElement
    		Synopsis
    			Store newElement at key in the receiver. Answer newElement.
    		Definition: <abstractDictionary>
    		If lookup succeeds for key, then newElement replaces the element previously stored at key.
    		Otherwise, the newElement is stored at the new key. In either case, subsequent successful
    		lookups for key will answer newElement.  Answer newElement.

    		The result is undefined if the key is nil.

		This clearly indicates that different smalltalks where doing different assumptions."
	
	
	
	| dict1  |
	dict1 := NXTDictionary new.
	self shouldnt: [ dict1 at: nil put: #none] raise: NXTError.
	self assert: (dict1 at: nil) = #none. 
	! !

!NXTDictionaryTest methodsFor: 'basic tests' stamp: 'mab 8/18/2008 18:34'!
testAtPut
	"self run: #testAtPut"
	"self debug: #testAtPut"
	
	| adictionary |
	adictionary := NXTDictionary new.
	adictionary at: #a put: 3.
	self assert: (adictionary at: #a) = 3.
	adictionary at: #a put: 3.
	adictionary at: #a put: 4.
	self assert: (adictionary at: #a) = 4.
	adictionary at: nil put: 666.
	self assert: (adictionary at: nil) = 666! !

!NXTDictionaryTest methodsFor: 'basic tests' stamp: 'mab 8/18/2008 18:34'!
testAtPutNil
	"self run: #testAtPut"
	"self debug: #testAtPut"
	
	| dict |
	dict := NXTDictionary new.
	dict at: nil put: 1.
	self assert: (dict at: nil) = 1.
	dict at: #a put: nil.
	self assert: (dict at: #a) = nil.
	dict at: nil put: nil.
	self assert: (dict at: nil) = nil.
	
	
	! !

!NXTDictionaryTest methodsFor: 'association tests' stamp: 'mab 8/18/2008 18:35'!
testIncludesAssociation
	"self run:#testIncludesAssociation"
	
	| dict |
	dict := NXTDictionary new.
	dict at: #a put: 1.
	dict at: #b put: 2.
	self assert: (dict includesAssociation: (#a -> 1)).
	self assert: (dict includesAssociation: (#b -> 2)).
	
	! !

!NXTDictionaryTest methodsFor: 'association tests' stamp: 'mab 8/18/2008 18:35'!
testIncludesAssociationNoValue
	"self run:#testIncludesAssociationNoValue"
	"self debug:#testIncludesAssociationNoValue"
	
	| dict a1 a3 |
	a1 := NXTAssociation key: #Italie.
	a3 := NXTAssociation key: #France value: 'Paris'.
	
	self assert: (a1 key = #Italie).
	self assert: (a1 value isNil).
	
	dict := NXTDictionary new.
	dict add: a1.
	dict add: a3.
	self assert: (dict includesKey: #France).
	self assert: (dict includesKey: #Italie).
	self assert: (dict at: #Italie) isNil.
	self assert: (dict at: #France) = 'Paris'

	
	
	! !

!NXTDictionaryTest methodsFor: 'basic tests' stamp: 'mab 8/18/2008 18:35'!
testIncludesKey
	"self run:#testIncludesKey"
	"self debug:#testIncludesKey"
	
	| dict a1 a2 a3 |
	a1 := NXTAssociation key: 'Italie'.
	a2 := NXTAssociation new.
	a3 := NXTAssociation key: 'France' value: 'Paris'.
	
	dict := NXTDictionary new.
	dict add: a1 .
	dict add: a2.
	dict add: a3.
	self assert: (dict includesKey: #France).
	self assert: (dict includesKey: 'France').
	self assert: (dict includesKey: #Italie).
	self assert: (dict includesKey: nil).	
		
	self assert: (dict at: 'France' ) = 'Paris'.
! !

!NXTDictionaryTest methodsFor: 'keys and value tests' stamp: 'mab 8/19/2008 16:04'!
testKeyAtValue
	"self run: #testKeyAtValue"
	"self debug: #testKeyAtValue"
	
	| dict |
	dict := NXTDictionary new.
	dict at: #a put: 1.
	dict at: #b put: 2.
	dict at: #c put: 3.
	self assert: (dict keyAtValue: 2) = #b.
	self assert: (dict keyAtValue: 1) = #a.
	self should: [dict keyAtValue: 0] raise: NXTError.
! !

!NXTDictionaryTest methodsFor: 'keys and value tests' stamp: 'mab 8/19/2008 15:58'!
testKeys

	"self run:#testKeys "
	
	| a1 a2  dict | 
	a1 := NXTAssociation key: 'France' value: 'Paris'.
	a2 := NXTAssociation key: 'Italie' value: 'Rome'.
	dict := NXTDictionary new.
	dict add: a1.
	dict add: a2.
	self assert: (dict keys size) = 2.
	self assert: (dict keys includes: #France).! !

!NXTDictionaryTest methodsFor: 'keys and value tests' stamp: 'mab 8/19/2008 16:09'!
testKeysDo
	"self run: #testKeysDo"
	"self debug: #testKeysDo"
	
	| dict res |
	dict := NXTDictionary new.
	
	dict at: #a put: 33.
	dict at: #b put: 66.
	
	res := NXTOrderedCollection new.
	dict keysDo: [ :each | res add: each ].
	
	self assert: res asSet = #(a b) asSet.


	
	! !

!NXTDictionaryTest methodsFor: 'basic tests' stamp: 'mab 8/18/2008 18:36'!
testOccurrencesOf
	"self run:#testOccurrencesOf"
	
	| dict |
	dict := NXTDictionary new.
	dict at: #a put: 1.
	dict at: #b put: 2.
	dict at: #c put: 1.
	dict at: #d put: 3.
	dict at: nil put: nil.
	dict at: #z put: nil.
	
	
	self assert: (dict occurrencesOf: 1 ) = 2.
	self assert: (dict occurrencesOf: nil ) = 2.
	
	
	
	! !

!NXTDictionaryTest methodsFor: 'tests' stamp: 'mab 8/18/2008 18:37'!
testPseudo
	"(self run: #testPseudo)"
	"true and false are valid keys"
	
	| dict1  |
	dict1 := NXTDictionary new.
	self shouldnt: [dict1 at: true put: #true] raise: NXTError.
	self assert: (dict1 at: true) = #true.
		
	self shouldnt: [dict1 at: false put: #false] raise: NXTError.
	self assert: (dict1 at: false) = #false.! !

!NXTDictionaryTest methodsFor: 'implementation tests' stamp: 'mab 8/18/2008 18:37'!
testPseudoVariablesAreValidKeys
	"(self run: #testPseudoVariablesAreValidKeys)"
	"true and false are valid keys"
	
	| dict1  |
	dict1 := NXTDictionary new.
	self shouldnt: [dict1 at: true put: #true] raise: NXTError.
	self assert: (dict1 at: true) = #true.
		
	self shouldnt: [dict1 at: false put: #false] raise: NXTError.
	self assert: (dict1 at: false) = #false.! !

!NXTDictionaryTest methodsFor: 'keys and value tests' stamp: 'mab 8/19/2008 13:41'!
testRemoveKey
		"self run:#testRemoveKey "
	| dict | 
	dict := NXTDictionary new.
	dict at: #a put: 1.
	dict at: #b put: 2.
	self assert: (dict keys size) = 2.
	dict removeKey: #a.
	self assert: dict keys size  = 1.

	self should: [dict at: #a] raise: NXTError.
	self assert: (dict at: #b) = 2


	
	! !

!NXTDictionaryTest methodsFor: 'keys and value tests' stamp: 'mab 8/19/2008 15:43'!
testValues
	"self run:#testValues "
	
	| a1 a2 a3 dict | 
	a1 := NXTAssociation key: 'France' value: 'Paris'.
	a2 := NXTAssociation key: 'Italie' value: 'Rome'.
	dict := NXTDictionary new.
	dict add: a1.
	dict add: a2.
	
	self assert: (dict values size ) = 2.
	self assert: (dict values includes: 'Paris').
	a3 := NXTAssociation new.
	dict add: a3.
	self assert: (dict values size ) = 3.
	self assert: (dict values includes: nil).! !

NXTTestCase subclass: #NXTExecutionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Tests'!

!NXTExecutionTest methodsFor: 'as yet unclassified' stamp: 'mab 6/9/2008 16:10'!
helper: anObject
	^ anObject! !

!NXTExecutionTest methodsFor: 'as yet unclassified' stamp: 'mab 6/5/2008 15:43'!
testAutomaticEndOfExecutionWithRecursiveBlocks
	"If this does not crash, the test is ok"
	| array |
	array := NXTArray new: 10.
	1 to: 10 do: [ :index | array at: index put: index ].
	array do: [ :each | self helper: each ].! !

!NXTExecutionTest methodsFor: 'as yet unclassified' stamp: 'mab 8/12/2008 13:48'!
testNonLocalReturnInNestedBlocks
	[ [ ^ self ] value ] value.
	"if we get here, something went wrong"
	self fail.! !

NXTTestCase subclass: #NXTMetaclassesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Tests'!

!NXTMetaclassesTest methodsFor: 'as yet unclassified' stamp: 'mab 8/12/2008 14:14'!
testInheritance
	self assert: NXTBoolean class superclass = NXTObject class.
	self assert: NXTObject class superclass = NXTClass.
	self assert: NXTClass superclass = NXTObject.! !

!NXTMetaclassesTest methodsFor: 'as yet unclassified' stamp: 'mab 8/12/2008 14:13'!
testInstanceOfRelationships
	self assert: NXTObject class class = NXTMetaclass.
	self assert: NXTMetaclass class class = NXTMetaclass.! !

NXTTestCase subclass: #NXTSymbolTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Tests'!

!NXTSymbolTest methodsFor: 'as yet unclassified' stamp: 'mab 8/18/2008 18:20'!
testEquality
	self assert: #test = #test.
	self assert: #test == #test.! !

!NXTSymbolTest methodsFor: 'as yet unclassified' stamp: 'mab 8/12/2008 11:57'!
testLiteralArraySymbols
	| array |
	array := #(#NXTArray).
	self assert: (array at: 1) = #NXTArray! !

!NXTTestCase methodsFor: 'as yet unclassified' stamp: 'mab 6/9/2008 16:13'!
assert: aBoolean
	aBoolean ifFalse: [ NXTTestFailure new signal: 'Assertion failed' ].! !

!NXTTestCase methodsFor: 'as yet unclassified' stamp: 'mab 8/12/2008 13:45'!
fail
	^ self assert: false! !

!NXTTestCase methodsFor: 'as yet unclassified' stamp: 'mab 9/4/2008 15:59'!
run
	| testSelectors failed |
	failed := NXTOrderedCollection new.
	testSelectors := self class selectors select: [ :each | each startsWith: #test ].
	('Testing class ' , self class name, ': ') print.
	testSelectors do: [ :testSelector |
		[ 
		self perform: testSelector. '.' print ] on: NXTTestFailure do: [ :ex | 
			'F' print.
			failed add: testSelector ]].
	NXTString cr print.
	failed do: [ :selector |
		selector print. ' failed' printNl ].! !

!NXTTestCase methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 14:21'!
should: assertionBlock
	self assert: assertionBlock value.! !

!NXTTestCase methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 16:13'!
should: aBlock raise: anExceptionalEvent
	[ aBlock value. self assert: false ] on: anExceptionalEvent do: [ :ex | ^ true ].
	self assert: false.! !

!NXTTestCase methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 16:13'!
shouldnt: aBlock raise: anExceptionalEvent
	[ aBlock value ] on: anExceptionalEvent do: [ :ex | self assert: false ].! !

NXTObject subclass: #NXTTime
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTTime class methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 14:51'!
millisecondClockValue
	<NXTPrimitive: 39>! !

!NXTTime class methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 14:51'!
millisecondsToRun: timedBlock 
	"Answer the number of milliseconds timedBlock takes to return its value."

	| initialMilliseconds |
	initialMilliseconds := self millisecondClockValue.
	timedBlock value.
	^ self millisecondClockValue - initialMilliseconds! !

NXTObject subclass: #NXTTimer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Hardware'!

!NXTTimer class methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 15:03'!
now
	<NXTPrimitive: 10>! !

!NXTTimer class methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 15:04'!
waitFor: seconds
	| start |
	start := self now.
	[ self now - start < seconds ] whileTrue.! !

NXTObject subclass: #NXTUndefinedObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTUndefinedObject methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 18:15'!
ifNil: aBlock
	^ aBlock value! !

!NXTUndefinedObject methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 13:27'!
ifNil: nilBlock ifNotNil: ifNotNilBlock
	"Evaluate the block for nil because I'm == nil"

	^ nilBlock value! !

!NXTUndefinedObject methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 13:27'!
ifNotNil: ifNotNilBlock ifNil: nilBlock 
	"If I got here, I am nil, so evaluate the block nilBlock"

	^ nilBlock value! !

!NXTUndefinedObject methodsFor: 'as yet unclassified' stamp: 'mab 5/20/2008 14:22'!
isNil
	^ true! !

NXTObject subclass: #NXTUsb
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Hardware'!

!NXTUsb class methodsFor: 'as yet unclassified' stamp: 'mab 6/19/2008 15:10'!
isConnected
	<NXTPrimitive: 26>
	^ false! !

!NXTUsb class methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 14:03'!
packetSize
	^ 64! !

!NXTUsb class methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 14:08'!
read
	"Blocking. Reads the next incoming packet from the USB port"
	<NXTPrimitive: 27>! !

!NXTUsb class methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 19:31'!
send: aByteArray
	"Blocking. Sends a packet to the USB port"
	<NXTPrimitive: 33>! !

Object subclass: #NXTObjectMapper
	instanceVariableNames: 'objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTObjectMapper class methodsFor: 'as yet unclassified' stamp: 'mab 3/17/2008 17:15'!
on: objectList
	^ self new objects: objectList! !

!NXTObjectMapper methodsFor: 'as yet unclassified' stamp: 'mab 7/9/2008 14:20'!
idFor: anObject
	^ (self objects indexOf: anObject ifAbsent: [ self error: 'Non-mappable object' ]) - 1! !

!NXTObjectMapper methodsFor: 'accessing' stamp: 'mab 3/17/2008 17:15'!
objects
	^ objects! !

!NXTObjectMapper methodsFor: 'accessing' stamp: 'mab 3/17/2008 17:15'!
objects: anObject
	objects := anObject! !

!Object methodsFor: '*nxtalk' stamp: 'mab 8/15/2008 16:22'!
isNXTObject
	^ false! !

RBProgramNodeVisitor subclass: #NXTAbstractCodeCompiler
	instanceVariableNames: 'literals bytecodes arguments temporaries compilerContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTAbstractCodeCompiler class methodsFor: 'as yet unclassified' stamp: 'mab 9/10/2008 19:04'!
bytecodes
	^ Dictionary new
		at: #return put: 2r00000000;
		at: #dup put: 2r00000001;
		at: #pop put: 2r00000010;
		at: #pushSelf put: 2r00000011;
		at: #pushNil put: 2r000000100;
		at: #pushTrue put: 2r00000101;
		at: #pushFalse put: 2r00000110;
		at: #pushThisContext put: 2r00000111;
		at: #pushArg put: 2r00001000;
		at: #pushTemp put: 2r00010000;
		at: #popTemp put: 2r00011000;
		at: #pushInst put: 2r00100000;
		at: #popInst put: 2r01000000;
		at: #pushLiteral put: 2r01100000;
		at: #pushBlock put: 2r10000000;
		at: #superSend put: 2r10100000;
		at: #send put: 2r11000000;
		yourself! !

!NXTAbstractCodeCompiler class methodsFor: 'as yet unclassified' stamp: 'mab 9/10/2008 18:59'!
maxArguments
	^ 8! !

!NXTAbstractCodeCompiler class methodsFor: 'as yet unclassified' stamp: 'mab 9/10/2008 18:59'!
maxInstVars
	^ 32! !

!NXTAbstractCodeCompiler class methodsFor: 'as yet unclassified' stamp: 'mab 9/10/2008 19:00'!
maxTemps
	^ 8! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 9/10/2008 18:31'!
acceptAssignmentNode: anAssignmentNode
	| pushNeeded |
	self visitNode: anAssignmentNode value.
	pushNeeded := anAssignmentNode parent isSequence not or: [ self lastStatement ].
	pushNeeded ifTrue: [ self addBytecode: #dup ].
	self popVariable: anAssignmentNode variable name.
	^ pushNeeded! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 9/10/2008 18:35'!
acceptBlockNode: aBlockNode
	| block |
	block := NXTBlockCompiler new
		compilerContext: self;
		compile: aBlockNode.
	self addBytecode: #pushBlock argument: (self mapLiteral: block).
	self image addObject: block.
	^ true! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 9/10/2008 18:36'!
acceptCascadeNode: cascadeNode
	self visitNode: cascadeNode receiver.
	cascadeNode messages size - 1 timesRepeat: [ self addBytecode: #dup ].
	cascadeNode messages 
		do: [ :message | self visitNode: message ]
		separatedBy: [ self addBytecode: #pop ].
	^ true! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 9/10/2008 18:45'!
acceptLiteralNode: aLiteralNode
	self processLiteral: aLiteralNode value.
	^ true
	! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 9/10/2008 18:46'!
acceptMessageNode: aMessageNode
	| literal |
	self primitive ifNotNil: [ ^ self ].
	aMessageNode isCascaded not ifTrue: [self visitNode: aMessageNode receiver].
	aMessageNode arguments do: [:each | self visitNode: each].
	literal := self mapLiteral: (self image symbolAt: aMessageNode selector).
	(aMessageNode receiver isVariable and: [ aMessageNode receiver name = 'super' ])
		ifTrue: [ self addBytecode: #superSend argument: literal]
		ifFalse: [ self addBytecode: #send argument: literal].
	^ true! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 6/12/2008 15:21'!
acceptReturnNode: aReturnNode
	(aReturnNode value isVariable and: [ aReturnNode value name = 'self' ] and: [ self compilesBlock not]) ifFalse: [
		super acceptReturnNode: aReturnNode.
		self addBytecode: #return ].
	^ false! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 9/10/2008 18:52'!
acceptVariableNode: variableNode
	self pushVariable: variableNode name.
	^ true! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 9/10/2008 18:29'!
addBytecode: aSymbol
	self addBytecode: aSymbol argument: 0! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 9/10/2008 18:28'!
addBytecode: aSymbol argument: aNumber
	self bytecodes add: (self class bytecodes at: aSymbol) + aNumber.
	! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/28/2008 19:26'!
allArguments
	^ arguments! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/28/2008 19:12'!
allTemporaries
	^ temporaries! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:12'!
arguments
	^ arguments! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:12'!
arguments: anObject
	arguments := anObject! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:14'!
bytecodes
	^ bytecodes! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:14'!
bytecodes: anObject
	bytecodes := anObject! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:17'!
compilerContext
	^ compilerContext! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:17'!
compilerContext: anObject
	compilerContext := anObject! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 6/12/2008 15:20'!
compilesBlock
	^ false! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 7/21/2008 15:34'!
convertLiteralArray: array
	| nxtArray |
	nxtArray := NXTArray new: array size.
	array doWithIndex: [ :element :index |
		nxtArray at: index put: (self extractLiteralValue: element) ].
	self image addObject: nxtArray.
	^ nxtArray! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 13:48'!
extractLiteralValue: value
	value ifNil: [
		^ self image specialObjectAt: #nil ].
	(value isKindOf: Boolean) ifTrue: [
		value 
			ifTrue: [ ^ self image specialObjectAt: #true ]
			ifFalse: [ ^ self image specialObjectAt: #false ]].
	value isSymbol ifTrue: [
		^ self image symbolAt: value ].
	value isString ifTrue: [
		^ self image addObject: value asNXTObject.
	].
	value isInteger ifTrue: [
		value asNXTObject isNXTObject 
			ifTrue: [ ^ self image addObject: value asNXTObject ].
		^ value ].
	value isArray ifTrue: [
		^ self convertLiteralArray: value ].
	self error: 'Unknown literal value'.! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 9/10/2008 18:57'!
ifArgument: aName doWithIndex: aBlock
	| index |
	index := self allArguments indexOf: aName.
	index > self class maxArguments ifTrue: [
		self error: ' Too many arguments' ].
	index isZero ifFalse: [ aBlock value: index - 1 ].
	! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 9/10/2008 18:58'!
ifInstVar: aName doWithIndex: aBlock
	| index |
	index := self instVarNames indexOf: aName.
	index > self class maxInstVars ifTrue: [
		self error: 'Too many instance variables' ].
	index isZero ifFalse: [ aBlock value: index - 1 ].
	! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:15'!
ifNXTClass: aName doWithName: aBlock
	| class |
	class := [ Smalltalk at: aName asSymbol ] on: Error do: [ ^ nil ].
	class isBehavior ifFalse: [ ^ nil ].
	((class inheritsFrom: NXTObject)  or: [ class = NXTObject ])
		ifTrue: [ aBlock value: aName ]
		ifFalse: [ (aName startsWith: 'NXT') ifFalse: [ 
			self ifNXTClass: 'NXT', aName doWithName: aBlock ]].! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 9/10/2008 19:00'!
ifTemporary: aName doWithIndex: aBlock
	| index |
	index := self allTemporaries indexOf: aName.
	index > self class maxTemps ifTrue: [
		self error: 'Too many temps' ].
	index isZero ifFalse: [ aBlock value: index - 1 ].
	! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:17'!
image
	^ self compilerContext image! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 4/23/2008 19:28'!
initialize
	literals := OrderedCollection new.
	bytecodes := OrderedCollection new.
	arguments := OrderedCollection new.
	temporaries := OrderedCollection new.
	half := false.! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:18'!
instVarNames
	^ self compilerContext instVarNames! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/28/2008 20:05'!
lastStatement
	^ false! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:14'!
literals
	^ literals! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:14'!
literals: anObject
	literals := anObject! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 4/26/2008 17:44'!
mapLiteral: aLiteral
	^ (self literals indexOf: aLiteral ifAbsent: [ self literals add: aLiteral. self literals size ]) - 1! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 9/10/2008 18:49'!
popVariable: aName
	self ifTemporary: aName doWithIndex: [ :index |
		^ self addBytecode: #popTemp argument: index ].
	self ifInstVar: aName doWithIndex: [ :index |
		^ self addBytecode: #popInst argument: index ].
	self error: 'Unknown variable'.! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/28/2008 15:37'!
primitive
	^ nil! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 9/10/2008 18:45'!
processLiteral: value
	value ifNil: [ ^ self addBytecode: #pushNil ].
	(value isKindOf: Boolean) ifTrue: [ value 
			ifTrue: [ ^ self addBytecode: #pushTrue ]
			ifFalse: [ ^ self addBytecode: #pushFalse ]].
	value isSymbol ifTrue: [ ^ self pushLiteral: (self image symbolAt: value) ].
	value isString ifTrue: [ ^ self pushLiteral: (self image 
		addObject: value asNXTObject) ].
	value isInteger ifTrue: [ value asNXTObject isNXTObject 
			ifTrue: [ ^ self pushLiteral: (self image addObject: value asNXTObject) ].
		^ self pushLiteral: value ].
	value isArray ifTrue: [
		^ self pushLiteral: (self convertLiteralArray: value) ].
	self error: 'Unknown literal value'.! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 9/10/2008 18:44'!
pushLiteral: literal
	self addBytecode: #pushLiteral argument: (self mapLiteral: literal)! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 9/11/2008 11:29'!
pushVariable: aName
	aName = 'self' ifTrue: [ ^ self addBytecode: #pushSelf ].
	aName = 'Smalltalk' ifTrue: [ 
		^ self pushLiteral: self image systemDictionary].
	aName = 'super' ifTrue: [ ^ self addBytecode: #pushSelf ].
	aName = 'thisContext' ifTrue: [ ^ self addBytecode: #pushThisContext ].
	aName = 'Processor' ifTrue: [ ^ self pushLiteral: (self image specialObjectAt: #Processor) ].
	self ifArgument: aName doWithIndex: [ :index |
		^ self addBytecode: #pushArg argument: index ].
	self ifTemporary: aName doWithIndex: [ :index |
		^ self addBytecode: #pushTemp argument: index ].
	self ifInstVar: aName doWithIndex: [ :index |
		^ self addBytecode: #pushInst argument: index ].
	self ifNXTClass: aName doWithName: [ :newName |
		^ self pushLiteral: (self image classAt: newName asSymbol) ].
	self error: 'Unknown variable'.! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:14'!
temporaries
	^ temporaries! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:14'!
temporaries: anObject
	temporaries := anObject! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 4/26/2008 17:44'!
visitArgument: argumentNode
	self arguments add: argumentNode name! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 4/26/2008 17:47'!
visitTemporaryVariable: aNode
	self temporaries add: aNode name.! !

NXTAbstractCodeCompiler subclass: #NXTBlockCompiler
	instanceVariableNames: 'lastStatement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTBlockCompiler methodsFor: 'as yet unclassified' stamp: 'mab 9/11/2008 13:51'!
acceptSequenceNode: aSequenceNode 
	self visitTemporaryVariables: aSequenceNode temporaries.
	aSequenceNode statements
		ifNotEmpty: [ aSequenceNode statements 
			allButLastDo: [:each | (self visitNode: each) 
				ifTrue: [self addBytecode: #pop]].
			self lastStatement: true.
			self visitNode: (aSequenceNode statements last)]
		ifEmpty: [ self addBytecode: #pushNil ].
	self addBytecode: #blockReturn! !

!NXTBlockCompiler methodsFor: 'as yet unclassified' stamp: 'mab 4/28/2008 19:27'!
allArguments
	^ self arguments, self compilerContext allArguments! !

!NXTBlockCompiler methodsFor: 'as yet unclassified' stamp: 'mab 4/28/2008 19:27'!
allTemporaries
	^ self temporaries, self compilerContext allTemporaries! !

!NXTBlockCompiler methodsFor: 'as yet unclassified' stamp: 'mab 5/22/2008 14:37'!
compile: aBlockNode
	self visitArguments: aBlockNode arguments.
	self visitNode: aBlockNode body.
	^ (NXTImageCompiledBlock 
		bytecodes: self bytecodes
		literals: self literals)
		tempCount: self temporaries size! !

!NXTBlockCompiler methodsFor: 'as yet unclassified' stamp: 'mab 6/12/2008 15:20'!
compilesBlock
	^ true! !

!NXTBlockCompiler methodsFor: 'accessing' stamp: 'mab 5/7/2008 17:44'!
initialize
	super initialize.
	lastStatement := false.! !

!NXTBlockCompiler methodsFor: 'accessing' stamp: 'mab 4/28/2008 20:04'!
lastStatement
	^ lastStatement! !

!NXTBlockCompiler methodsFor: 'accessing' stamp: 'mab 4/28/2008 20:04'!
lastStatement: anObject
	lastStatement := anObject! !

NXTAbstractCodeCompiler subclass: #NXTMethodCompiler
	instanceVariableNames: 'primitive'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTMethodCompiler methodsFor: 'as yet unclassified' stamp: 'mab 5/29/2008 14:59'!
acceptMethodNode: aMethodNode
	aMethodNode pragmas do: [:each | self visitNode: each].
	self visitMethodArguments: aMethodNode arguments.
	self visitNode: aMethodNode body! !

!NXTMethodCompiler methodsFor: 'as yet unclassified' stamp: 'mab 5/29/2008 15:25'!
acceptPragmaNode: aPragmaNode
	| pragma newMethodNode |
	pragma := aPragmaNode pragma.
	pragma keyword = #NXTPrimitive: ifTrue: [
		self primitive: (pragma argumentAt: 1) ].
	pragma keyword = #nxtTakeMethodFrom: ifTrue: [ 
		newMethodNode := SqueakParser parseMethod: ((Smalltalk at: (pragma argumentAt: 1))
			compiledMethodAt: (aPragmaNode parent selector )) getSource.
		aPragmaNode parent arguments: newMethodNode arguments.
		aPragmaNode parent body: newMethodNode body ].! !

!NXTMethodCompiler methodsFor: 'as yet unclassified' stamp: 'mab 9/11/2008 14:02'!
acceptSequenceNode: aSequenceNode 
	self primitive ifNotNil: [ ^ nil ].
	self visitTemporaryVariables: aSequenceNode temporaries.
	aSequenceNode statements do: [:each | (self visitNode: each) ifTrue: [self addBytecode: #pop]].
	"(aSequenceNode statements isEmpty or: [
		aSequenceNode statements last isReturn not]) ifTrue: [ "
			self addBytecode: #pushSelf. self addBytecode: #return "]."! !

!NXTMethodCompiler methodsFor: 'as yet unclassified' stamp: 'mab 4/23/2008 18:29'!
compileMethod: aCompiledMethod
	| ast |
	ast := SqueakParser parseMethod: aCompiledMethod getSource.
	self visitNode: ast.
	self primitive ifNil: [ ^ (NXTImageCompiledMethod 
		bytecodes: self bytecodes 
		literals: self literals)
		tempCount: self temporaries size ].
	^ NXTImageCompiledMethod primitive: self primitive! !

!NXTMethodCompiler methodsFor: 'accessing' stamp: 'mab 4/16/2008 14:37'!
primitive
	^ primitive! !

!NXTMethodCompiler methodsFor: 'accessing' stamp: 'mab 4/16/2008 14:08'!
primitive: anObject
	primitive := anObject! !

Model subclass: #NXTConnectDialog
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-User Interface'!

!NXTConnectDialog class methodsFor: 'as yet unclassified' stamp: 'mab 6/12/2008 13:18'!
open
	^ ToolBuilder open: self! !

!NXTConnectDialog methodsFor: 'as yet unclassified' stamp: 'mab 6/22/2008 13:57'!
buildWith: builder
	| windowSpec |
	windowSpec := builder pluggableWindowSpec new.
	windowSpec model: self.
	windowSpec label: 'NXT - Transfer'.
	windowSpec extent: 300@200.
	windowSpec children: OrderedCollection new.
	windowSpec children add: (builder pluggableButtonSpec new
		model: self;
		label: 'Socket (to localhost:10000)';
		action: #socket;
		frame: (0.1@0.1 corner: 0.9@0.3);
		yourself).
	windowSpec children add: (builder pluggableButtonSpec new
		model: self;
		label: 'Usb connection';
		action: #usb;
		frame: (0.1@0.4 corner: 0.9@0.6);
		yourself).
	windowSpec children add: (builder pluggableButtonSpec new
		model: self;
		label: 'Serial Port 3';
		action: #serial;
		frame: (0.1@0.7 corner: 0.9@0.9);
		yourself).
	^builder build: windowSpec! !

!NXTConnectDialog methodsFor: 'accessing' stamp: 'mab 6/22/2008 15:46'!
connection
	^ connection! !

!NXTConnectDialog methodsFor: 'accessing' stamp: 'mab 6/22/2008 15:46'!
connection: anObject
	connection := anObject! !

!NXTConnectDialog methodsFor: 'actions' stamp: 'mab 6/22/2008 16:07'!
socket
	| con |
	[ con := NXTSocketConnection connect ]
		on: Error
		do: [ self inform: 'Could not connect to socket' ].
	self connection: con.
	self changed.
	self connection ifNotNil: [ self containingWindow delete ].! !

!NXTConnectDialog methodsFor: 'actions' stamp: 'mab 6/22/2008 13:58'!
usb
	self error: 'Usb connection is yet not implemented!!'! !

Model subclass: #NXTTransferToolOld
	instanceVariableNames: 'localSelection localClasses remoteClasses dialogOpen connection connectButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-User Interface'!
